using System;
using System.Collections.Generic;
using System.Reflection;
using System.Runtime.CompilerServices;
using Com.Raritan.AudioCore.Impl.Audio;
using Com.Raritan.AudioCore.Impl.Rap.Pdu;
using Com.Raritan.Core;
using Com.Raritan.Core.Impl;
using log4net;

namespace Com.Raritan.AudioCore.Impl.Rap;

internal abstract class b : Com.Raritan.Core.Impl.h, Com.Raritan.AudioCore.Impl.Audio.b
{
	protected new Com.Raritan.AudioCore.Impl.Rap.Pdu.j i;

	protected new Com.Raritan.AudioCore.Impl.Rap.Pdu.m l;

	protected Com.Raritan.AudioCore.Impl.Rap.Pdu.m m;

	protected Com.Raritan.AudioCore.Impl.Rap.Pdu.h n;

	protected Com.Raritan.AudioCore.Impl.Rap.Pdu.h o;

	protected Com.Raritan.AudioCore.Impl.Rap.Pdu.n p;

	protected new Com.Raritan.AudioCore.Impl.Rap.Pdu.a q;

	protected Com.Raritan.AudioCore.Impl.Rap.Pdu.g r;

	protected Com.Raritan.AudioCore.Impl.Rap.Pdu.d s;

	protected Com.Raritan.AudioCore.Impl.Rap.Pdu.f t;

	protected Com.Raritan.AudioCore.Impl.Rap.Pdu.e u;

	protected Com.Raritan.AudioCore.Impl.Rap.Pdu.i v;

	protected Com.Raritan.AudioCore.Impl.Rap.Pdu.l w;

	protected Com.Raritan.AudioCore.Impl.Rap.Pdu.l x;

	protected Com.Raritan.AudioCore.Impl.Rap.Pdu.c y;

	protected Com.Raritan.AudioCore.Impl.Rap.Pdu.c z;

	protected Com.Raritan.AudioCore.Impl.Rap.Pdu.b aa;

	protected new Com.Raritan.AudioCore.Impl.Rap.Pdu.b ab;

	protected Com.Raritan.AudioCore.Impl.Rap.Pdu.o ac;

	protected Com.Raritan.AudioCore.Impl.Rap.Pdu.k ad;

	private Com.Raritan.AudioCore.Impl.a m_ae;

	private Com.Raritan.AudioCore.e m_af;

	private Com.Raritan.AudioCore.e m_ag;

	private Com.Raritan.AudioCore.c m_ah;

	private Com.Raritan.AudioCore.c m_ai;

	protected uint aj;

	protected int ak;

	private Com.Raritan.AudioCore.Impl.Audio.d m_al;

	private Com.Raritan.AudioCore.Impl.Audio.f am;

	private int an;

	private int ao;

	protected int ap = 120;

	protected int aq = 120;

	protected bool ar;

	internal new static b a(Com.Raritan.Core.Impl.a A_0, ILog A_1, Com.Raritan.AudioCore.Impl.a A_2, Com.Raritan.AudioCore.e A_3, Com.Raritan.AudioCore.c A_4, Com.Raritan.AudioCore.e A_5, Com.Raritan.AudioCore.c A_6, uint A_7, int A_8)
	{
		c c2 = new c();
		c2.b(A_0, A_1, A_2, A_3, A_4, A_5, A_6, A_7, A_8);
		c2.g();
		b b2 = a(A_0, A_1, A_2, A_3, A_4, A_5, A_6, A_7, A_8, c2.j, ((Com.Raritan.Core.Impl.h)c2).k);
		b2.j = c2.j;
		((Com.Raritan.Core.Impl.h)b2).k = ((Com.Raritan.Core.Impl.h)c2).k;
		return b2;
	}

	private new static b a(Com.Raritan.Core.Impl.a A_0, ILog A_1, Com.Raritan.AudioCore.Impl.a A_2, Com.Raritan.AudioCore.e A_3, Com.Raritan.AudioCore.c A_4, Com.Raritan.AudioCore.e A_5, Com.Raritan.AudioCore.c A_6, uint A_7, int A_8, int A_9, int A_10)
	{
		b b2 = null;
		try
		{
			string text = Com.Raritan.Core.Impl.n.a(A_9, A_10, '_');
			string text2 = "Com.Raritan.AudioCore.Impl.Rap.V" + text + ".RapHandlerV" + text;
			A_1.DebugFormat(Com.Raritan.Core.b.d("Trying to load protocol handler: {0}"), text2);
			b2 = (b)Assembly.GetCallingAssembly().CreateInstance(text2);
			if (b2 == null)
			{
				throw new Com.Raritan.AudioCore.a(string.Format(Com.Raritan.Core.b.d("Protocol handler for RAP version {0} not found"), text.Replace('_', '.')));
			}
		}
		catch (Com.Raritan.AudioCore.a a2)
		{
			A_1.FatalFormat(Com.Raritan.Core.b.d("Unable to load protocol handler: {0}!"), a2);
			throw a2;
		}
		catch (Exception arg)
		{
			string a_ = Com.Raritan.Core.b.d("Unable to load protocol handler!");
			A_1.FatalFormat(Com.Raritan.Core.b.d("Unable to load protocol handler: {0}!"), arg);
			throw new Com.Raritan.AudioCore.a(a_);
		}
		b2.b(A_0, A_1, A_2, A_3, A_4, A_5, A_6, A_7, A_8);
		return b2;
	}

	[SpecialName]
	public Com.Raritan.AudioCore.Impl.Audio.d al()
	{
		return this.m_al;
	}

	[SpecialName]
	public Com.Raritan.AudioCore.Impl.Audio.f ak()
	{
		return am;
	}

	public new void b(Com.Raritan.Core.Impl.a A_0, ILog A_1, Com.Raritan.AudioCore.Impl.a A_2, Com.Raritan.AudioCore.e A_3, Com.Raritan.AudioCore.c A_4, Com.Raritan.AudioCore.e A_5, Com.Raritan.AudioCore.c A_6, uint A_7, int A_8)
	{
		this.m_ae = A_2;
		this.m_af = A_3;
		this.m_ah = A_4;
		this.m_ag = A_5;
		this.m_ai = A_6;
		this.aj = A_7;
		this.ak = A_8;
		a(A_0, A_1, A_2);
	}

	public virtual void ag()
	{
		base.h();
		i = null;
		l = null;
		this.m = null;
		this.p = null;
		q = null;
		this.r = null;
		this.s = null;
		this.t = null;
		this.n = null;
		this.o = null;
		this.u = null;
		this.v = null;
		this.w = null;
		this.x = null;
		this.y = null;
		this.z = null;
		this.aa = null;
		ab = null;
		this.ac = null;
		this.ad = null;
	}

	void IDisposable.Dispose()
	{
		//ILSpy generated this explicit interface implementation from .override directive in ag
		this.ag();
	}

	protected virtual string ae()
	{
		return "RAP";
	}

	protected virtual Com.Raritan.Core.e c(string A_0)
	{
		return new Com.Raritan.AudioCore.a(A_0);
	}

	public virtual void ah()
	{
		if (((Com.Raritan.Core.Impl.n)this).g)
		{
			((Com.Raritan.Core.Impl.n)this).e = false;
			try
			{
				a(-1845362685);
			}
			catch (Exception)
			{
			}
		}
		if (am != null)
		{
			am.i();
			am = null;
		}
		if (this.m_al != null)
		{
			this.m_al.h();
			this.m_al = null;
		}
		this.m_ae.a(Com.Raritan.AudioCore.f.a.a);
		this.m_ae.b(Com.Raritan.AudioCore.f.a.a);
		base.ab();
	}

	protected virtual void b(bool A_0, Exception A_1)
	{
		this.m_ae.a(Com.Raritan.AudioCore.f.a.a);
		this.m_ae.b(Com.Raritan.AudioCore.f.a.a);
		c(A_0, A_1);
	}

	protected virtual void af()
	{
		i.a(((Com.Raritan.Core.Impl.n)this).c);
		l.b(((Com.Raritan.Core.Impl.n)this).b);
		int num;
		this.m.a(num = l.b());
		j = num;
		int num2;
		this.m.b(num2 = l.c());
		base.k = num2;
		((Com.Raritan.Core.Impl.n)this).d.InfoFormat(Com.Raritan.Core.b.d("Device supports protocol version {0}"), l.a());
		this.m.a(((Com.Raritan.Core.Impl.n)this).c);
	}

	protected override void k()
	{
		base.k();
		if (this.m_ah != null)
		{
			am = ((Com.Raritan.AudioCore.Impl.Audio.c)this.m_af).a(((Com.Raritan.Core.Impl.n)this).d, this.m_ah, this.m_ae);
			am.h();
		}
		if (this.m_ai != null)
		{
			this.m_al = ((Com.Raritan.AudioCore.Impl.Audio.c)this.m_ag).a(((Com.Raritan.Core.Impl.n)this).d, this.m_ai, this.m_ae, this);
			this.m_al.j();
		}
	}

	protected virtual void ad()
	{
		aa();
		while (((Com.Raritan.Core.Impl.n)this).e)
		{
			byte b2 = bx();
			if (!((Com.Raritan.Core.Impl.n)this).e)
			{
				break;
			}
			switch (b2)
			{
			case 128:
				w();
				break;
			case 0:
				v();
				break;
			case 1:
				u();
				break;
			case 2:
				t();
				break;
			case 3:
				s();
				break;
			case 129:
				r();
				break;
			default:
				((Com.Raritan.Core.Impl.n)this).d.ErrorFormat(Com.Raritan.Core.b.d("Unknown Protocol message received:") + " " + b2);
				throw new Com.Raritan.AudioCore.a(Com.Raritan.Core.b.d("Protocol Error: Unknown Protocol message received"));
			}
			if (((Com.Raritan.Core.Impl.n)this).h)
			{
				a(b2);
			}
		}
	}

	private void aa()
	{
		if (base.f != null)
		{
			z();
			return;
		}
		if (base.c != null && base.d != null)
		{
			y();
			return;
		}
		if (base.e != null)
		{
			x();
			return;
		}
		throw new Com.Raritan.AudioCore.a(Com.Raritan.Core.b.d("No proper authentication scheme found"));
	}

	private void z()
	{
		f();
	}

	private void y()
	{
		e();
	}

	private void x()
	{
		d();
		byte[] array = p();
		if (array == null || array.Length != 64)
		{
			throw new Com.Raritan.AudioCore.a(Com.Raritan.Core.b.d("Protocol error: bad challenge size"));
		}
		string text = Com.Raritan.Core.Impl.f.b(array);
		Com.Raritan.Core.Impl.i.b a_ = (text.StartsWith("{SHA256}") ? Com.Raritan.Core.Impl.i.b.c : Com.Raritan.Core.Impl.i.b.a);
		string a_2 = a(array, a_);
		b(a_2);
	}

	protected void ac()
	{
		a(this.m_ah, this.m_ai, this.aj, this.ak);
	}

	public new void b(Com.Raritan.AudioCore.c A_0, byte[] A_1, int A_2, int A_3)
	{
		a(A_0, A_1, A_2, A_3);
	}

	void Com.Raritan.AudioCore.Impl.Audio.b.a(Com.Raritan.AudioCore.c A_0, byte[] A_1, int A_2, int A_3)
	{
		//ILSpy generated this explicit interface implementation from .override directive in b
		this.b(A_0, A_1, A_2, A_3);
	}

	public new void b(int A_0)
	{
		an = A_0;
		a(2, A_0);
	}

	public int aj()
	{
		if (an != 0)
		{
			return an;
		}
		return ap;
	}

	public new void c(int A_0)
	{
		ao = A_0;
		a(1, A_0);
	}

	public int ai()
	{
		if (ao != 0)
		{
			return ao;
		}
		return aq;
	}

	private void w()
	{
		if (b(out var A_))
		{
			if (ar)
			{
				this.m_ae.a((this.m_ah != null) ? Com.Raritan.AudioCore.f.a.b : Com.Raritan.AudioCore.f.a.a);
				this.m_ae.b((this.m_ai != null) ? Com.Raritan.AudioCore.f.a.b : Com.Raritan.AudioCore.f.a.a);
			}
			return;
		}
		d d2 = new d(1, A_);
		this.m_ae.a(d2);
		throw new Com.Raritan.AudioCore.a(A_, d2.b());
	}

	private void v()
	{
		o();
		b();
	}

	private void u()
	{
		n();
	}

	private void t()
	{
		Com.Raritan.Core.g g = m();
		if (g.k() == -1845362682)
		{
			this.m_ae.b(Com.Raritan.AudioCore.f.a.c);
			if (this.m_al != null)
			{
				this.m_al.k();
			}
		}
		else if (g.k() == -1845362681)
		{
			this.m_ae.b(Com.Raritan.AudioCore.f.a.b);
			if (this.m_al != null)
			{
				this.m_al.i();
			}
		}
		else if (g.k() == -1845362679)
		{
			this.m_ae.a(Com.Raritan.AudioCore.f.a.b);
		}
		else if (g.k() == -1845362680)
		{
			this.m_ae.a(Com.Raritan.AudioCore.f.a.c);
			if (am != null)
			{
				am.f();
			}
		}
		else
		{
			this.m_ae.a(g);
			if (g.i())
			{
				throw new Com.Raritan.AudioCore.a(g.k(), g.b());
			}
		}
	}

	private void s()
	{
		a(out var A_, out var A_2, out var A_3);
		if (this.m_ah != null && this.m_ah.a(A_) && am != null)
		{
			am.a(this.m_ah, A_2, 0, A_3);
		}
	}

	private void r()
	{
		if (!a(out var A_))
		{
			d d2 = new d(1, A_);
			this.m_ae.a(d2);
			throw new Com.Raritan.AudioCore.a(A_, d2.b());
		}
		if (an != 0)
		{
			if (this.m_al != null)
			{
				this.m_al.b(an);
			}
			ap = an;
			an = 0;
		}
		else if (ao != 0)
		{
			if (am != null)
			{
				am.a(ao);
			}
			aq = ao;
			ao = 0;
		}
	}

	private byte[] p()
	{
		a(this.t);
		this.t.b(((Com.Raritan.Core.Impl.n)this).b);
		return this.t.a();
	}

	private new bool b(out int A_0)
	{
		a(this.v);
		this.v.a(((Com.Raritan.Core.Impl.n)this).b, A_1: true);
		A_0 = this.v.a();
		return this.v.b();
	}

	private void o()
	{
		a(this.w);
		this.w.a(((Com.Raritan.Core.Impl.n)this).b, A_1: true);
	}

	private void n()
	{
		a(this.y);
		this.y.a(((Com.Raritan.Core.Impl.n)this).b, A_1: true);
	}

	private Com.Raritan.Core.g m()
	{
		a(this.o);
		this.o.a(((Com.Raritan.Core.Impl.n)this).b, A_1: true);
		return this.o.a();
	}

	private new void a(out Com.Raritan.AudioCore.c A_0, out byte[] A_1, out int A_2)
	{
		a(this.aa);
		this.aa.a(((Com.Raritan.Core.Impl.n)this).b, A_1: true);
		A_0 = this.aa.b();
		A_1 = this.aa.a();
		A_2 = this.aa.d();
	}

	private new bool a(out int A_0)
	{
		a(this.ad);
		this.ad.a(((Com.Raritan.Core.Impl.n)this).b, A_1: true);
		A_0 = this.ad.a();
		return this.ad.b();
	}

	private new void f()
	{
		lock (base.l)
		{
			a(this.p);
			this.p.a(base.f);
			this.p.a(((Com.Raritan.Core.Impl.n)this).c);
		}
	}

	private new void e()
	{
		lock (base.l)
		{
			a(q);
			q.a(base.c);
			q.b(base.d);
			q.a(((Com.Raritan.Core.Impl.n)this).c);
		}
	}

	private new void d()
	{
		lock (base.l)
		{
			a(this.r);
			this.r.a(((Com.Raritan.Core.Impl.n)this).c);
		}
	}

	private new void b(string A_0)
	{
		lock (base.l)
		{
			a(this.s);
			this.s.a(A_0);
			this.s.a(((Com.Raritan.Core.Impl.n)this).c);
		}
	}

	private new void a(int A_0)
	{
		lock (base.l)
		{
			a(this.n);
			this.n.a(A_0);
			this.n.a(((Com.Raritan.Core.Impl.n)this).c);
		}
	}

	private new void a(Com.Raritan.AudioCore.c A_0, Com.Raritan.AudioCore.c A_1, uint A_2, int A_3)
	{
		lock (base.l)
		{
			a(this.u);
			Dictionary<int, Com.Raritan.AudioCore.c> dictionary = new Dictionary<int, Com.Raritan.AudioCore.c>();
			if (A_0 != null)
			{
				dictionary.Add(1, A_0);
			}
			if (A_1 != null)
			{
				dictionary.Add(2, A_1);
			}
			this.u.a(A_3);
			this.u.a(A_2);
			this.u.a(dictionary);
			this.u.a(((Com.Raritan.Core.Impl.n)this).c);
		}
	}

	private new void c()
	{
		lock (base.l)
		{
			a(this.x);
			this.x.a(((Com.Raritan.Core.Impl.n)this).c);
		}
	}

	private new void b()
	{
		lock (base.l)
		{
			a(this.z);
			this.z.a(((Com.Raritan.Core.Impl.n)this).c);
		}
	}

	private new void a(Com.Raritan.AudioCore.c A_0, byte[] A_1, int A_2, int A_3)
	{
		lock (base.l)
		{
			a(ab);
			ab.a(A_0);
			ab.a(A_1);
			ab.d(A_2);
			ab.b(A_3);
			ab.a(((Com.Raritan.Core.Impl.n)this).c);
		}
	}

	private new void a(int A_0, int A_1)
	{
		lock (base.l)
		{
			a(this.ac);
			this.ac.a(A_0);
			this.ac.b(A_1);
			this.ac.a(((Com.Raritan.Core.Impl.n)this).c);
		}
	}
}
