using System;
using System.Globalization;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace SharpDX;

[Serializable]
[StructLayout(LayoutKind.Sequential, Pack = 4)]
[DefaultMember("Item")]
public struct ah : IEquatable<ah>, IFormattable
{
	public float a;

	public float b;

	public float c;

	public ah(float A_0)
	{
		this.a = (this.b = (this.c = A_0));
	}

	public ah(float A_0, float A_1, float A_2)
	{
		this.a = A_0;
		this.b = A_1;
		this.c = A_2;
	}

	public ah(a A_0)
	{
		this.a = A_0.g;
		this.b = A_0.h;
		this.c = A_0.i;
	}

	public ah(int A_0)
	{
		this.a = (float)((A_0 >> 16) & 0xFF) / 255f;
		this.b = (float)((A_0 >> 8) & 0xFF) / 255f;
		this.c = (float)(A_0 & 0xFF) / 255f;
	}

	public ah(float[] A_0)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("values");
		}
		if (A_0.Length != 3)
		{
			throw new ArgumentOutOfRangeException("values", "There must be three and only three input values for Color3.");
		}
		this.a = A_0[0];
		this.b = A_0[1];
		this.c = A_0[2];
	}

	[SpecialName]
	public float b(int A_0)
	{
		return A_0 switch
		{
			0 => this.a, 
			1 => this.b, 
			2 => this.c, 
			_ => throw new ArgumentOutOfRangeException("index", "Indices for Color3 run from 0 to 2, inclusive."), 
		};
	}

	[SpecialName]
	public void a(int A_0, float A_1)
	{
		switch (A_0)
		{
		case 0:
			this.a = A_1;
			break;
		case 1:
			this.b = A_1;
			break;
		case 2:
			this.c = A_1;
			break;
		default:
			throw new ArgumentOutOfRangeException("index", "Indices for Color3 run from 0 to 2, inclusive.");
		}
	}

	public int a()
	{
		uint num = 255u;
		uint num2 = (uint)(this.a * 255f);
		uint num3 = (uint)(this.b * 255f);
		uint num4 = (uint)(this.c * 255f);
		uint num5 = num4;
		num5 += num3 << 8;
		num5 += num2 << 16;
		return (int)(num5 + (num << 24));
	}

	public a d()
	{
		return new a(this.a, this.b, this.c);
	}

	public float[] b()
	{
		return new float[3] { this.a, this.b, this.c };
	}

	public static void e(ref ah A_0, ref ah A_1, out ah A_2)
	{
		A_2.a = A_0.a + A_1.a;
		A_2.b = A_0.b + A_1.b;
		A_2.c = A_0.c + A_1.c;
	}

	public static ah j(ah A_0, ah A_1)
	{
		return new ah(A_0.a + A_1.a, A_0.b + A_1.b, A_0.c + A_1.c);
	}

	public static void d(ref ah A_0, ref ah A_1, out ah A_2)
	{
		A_2.a = A_0.a - A_1.a;
		A_2.b = A_0.b - A_1.b;
		A_2.c = A_0.c - A_1.c;
	}

	public static ah i(ah A_0, ah A_1)
	{
		return new ah(A_0.a - A_1.a, A_0.b - A_1.b, A_0.c - A_1.c);
	}

	public static void c(ref ah A_0, ref ah A_1, out ah A_2)
	{
		A_2.a = A_0.a * A_1.a;
		A_2.b = A_0.b * A_1.b;
		A_2.c = A_0.c * A_1.c;
	}

	public static ah h(ah A_0, ah A_1)
	{
		return new ah(A_0.a * A_1.a, A_0.b * A_1.b, A_0.c * A_1.c);
	}

	public static void c(ref ah A_0, float A_1, out ah A_2)
	{
		A_2.a = A_0.a * A_1;
		A_2.b = A_0.b * A_1;
		A_2.c = A_0.c * A_1;
	}

	public static ah d(ah A_0, float A_1)
	{
		return new ah(A_0.a * A_1, A_0.b * A_1, A_0.c * A_1);
	}

	public static void a(ref ah A_0, out ah A_1)
	{
		A_1.a = 1f - A_0.a;
		A_1.b = 1f - A_0.b;
		A_1.c = 1f - A_0.c;
	}

	public static ah e(ah A_0)
	{
		return new ah(1f - A_0.a, 1f - A_0.b, 1f - A_0.c);
	}

	public static void a(ref ah A_0, ref ah A_1, ref ah A_2, out ah A_3)
	{
		float num = A_0.a;
		num = ((num > A_2.a) ? A_2.a : num);
		num = ((num < A_1.a) ? A_1.a : num);
		float num2 = A_0.b;
		num2 = ((num2 > A_2.b) ? A_2.b : num2);
		num2 = ((num2 < A_1.b) ? A_1.b : num2);
		float num3 = A_0.c;
		num3 = ((num3 > A_2.c) ? A_2.c : num3);
		num3 = ((num3 < A_1.c) ? A_1.c : num3);
		A_3 = new ah(num, num2, num3);
	}

	public static ah a(ah A_0, ah A_1, ah A_2)
	{
		a(ref A_0, ref A_1, ref A_2, out var A_3);
		return A_3;
	}

	public static void b(ref ah A_0, ref ah A_1, float A_2, out ah A_3)
	{
		A_3.a = A_0.a + A_2 * (A_1.a - A_0.a);
		A_3.b = A_0.b + A_2 * (A_1.b - A_0.b);
		A_3.c = A_0.c + A_2 * (A_1.c - A_0.c);
	}

	public static ah b(ah A_0, ah A_1, float A_2)
	{
		return new ah(A_0.a + A_2 * (A_1.a - A_0.a), A_0.b + A_2 * (A_1.b - A_0.b), A_0.c + A_2 * (A_1.c - A_0.c));
	}

	public static void a(ref ah A_0, ref ah A_1, float A_2, out ah A_3)
	{
		A_2 = ((A_2 > 1f) ? 1f : ((A_2 < 0f) ? 0f : A_2));
		A_2 = A_2 * A_2 * (3f - 2f * A_2);
		A_3.a = A_0.a + (A_1.a - A_0.a) * A_2;
		A_3.b = A_0.b + (A_1.b - A_0.b) * A_2;
		A_3.c = A_0.c + (A_1.c - A_0.c) * A_2;
	}

	public static ah a(ah A_0, ah A_1, float A_2)
	{
		A_2 = ((A_2 > 1f) ? 1f : ((A_2 < 0f) ? 0f : A_2));
		A_2 = A_2 * A_2 * (3f - 2f * A_2);
		return new ah(A_0.a + (A_1.a - A_0.a) * A_2, A_0.b + (A_1.b - A_0.b) * A_2, A_0.c + (A_1.c - A_0.c) * A_2);
	}

	public static void b(ref ah A_0, ref ah A_1, out ah A_2)
	{
		A_2.a = ((A_0.a > A_1.a) ? A_0.a : A_1.a);
		A_2.b = ((A_0.b > A_1.b) ? A_0.b : A_1.b);
		A_2.c = ((A_0.c > A_1.c) ? A_0.c : A_1.c);
	}

	public static ah g(ah A_0, ah A_1)
	{
		b(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void a(ref ah A_0, ref ah A_1, out ah A_2)
	{
		A_2.a = ((A_0.a < A_1.a) ? A_0.a : A_1.a);
		A_2.b = ((A_0.b < A_1.b) ? A_0.b : A_1.b);
		A_2.c = ((A_0.c < A_1.c) ? A_0.c : A_1.c);
	}

	public static ah f(ah A_0, ah A_1)
	{
		a(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void b(ref ah A_0, float A_1, out ah A_2)
	{
		A_2.a = 0.5f + A_1 * (A_0.a - 0.5f);
		A_2.b = 0.5f + A_1 * (A_0.b - 0.5f);
		A_2.c = 0.5f + A_1 * (A_0.c - 0.5f);
	}

	public static ah c(ah A_0, float A_1)
	{
		return new ah(0.5f + A_1 * (A_0.a - 0.5f), 0.5f + A_1 * (A_0.b - 0.5f), 0.5f + A_1 * (A_0.c - 0.5f));
	}

	public static void a(ref ah A_0, float A_1, out ah A_2)
	{
		float num = A_0.a * 0.2125f + A_0.b * 0.7154f + A_0.c * 0.0721f;
		A_2.a = num + A_1 * (A_0.a - num);
		A_2.b = num + A_1 * (A_0.b - num);
		A_2.c = num + A_1 * (A_0.c - num);
	}

	public static ah b(ah A_0, float A_1)
	{
		float num = A_0.a * 0.2125f + A_0.b * 0.7154f + A_0.c * 0.0721f;
		return new ah(num + A_1 * (A_0.a - num), num + A_1 * (A_0.b - num), num + A_1 * (A_0.c - num));
	}

	[SpecialName]
	public static ah e(ah A_0, ah A_1)
	{
		return new ah(A_0.a + A_1.a, A_0.b + A_1.b, A_0.c + A_1.c);
	}

	[SpecialName]
	public static ah d(ah A_0)
	{
		return A_0;
	}

	[SpecialName]
	public static ah d(ah A_0, ah A_1)
	{
		return new ah(A_0.a - A_1.a, A_0.b - A_1.b, A_0.c - A_1.c);
	}

	[SpecialName]
	public static ah c(ah A_0)
	{
		return new ah(0f - A_0.a, 0f - A_0.b, 0f - A_0.c);
	}

	[SpecialName]
	public static ah a(float A_0, ah A_1)
	{
		return new ah(A_1.a * A_0, A_1.b * A_0, A_1.c * A_0);
	}

	[SpecialName]
	public static ah a(ah A_0, float A_1)
	{
		return new ah(A_0.a * A_1, A_0.b * A_1, A_0.c * A_1);
	}

	[SpecialName]
	public static ah c(ah A_0, ah A_1)
	{
		return new ah(A_0.a * A_1.a, A_0.b * A_1.b, A_0.c * A_1.c);
	}

	[SpecialName]
	public static bool b(ah A_0, ah A_1)
	{
		return A_0.f(A_1);
	}

	[SpecialName]
	public static bool a(ah A_0, ah A_1)
	{
		return !A_0.f(A_1);
	}

	[SpecialName]
	public static ae b(ah A_0)
	{
		return new ae(1f, A_0.a, A_0.b, A_0.c);
	}

	[SpecialName]
	public static a a(ah A_0)
	{
		return new a(A_0.a, A_0.b, A_0.c);
	}

	[SpecialName]
	public static ah a(a A_0)
	{
		return new ah(A_0.g, A_0.h, A_0.i);
	}

	[SpecialName]
	public static ah a(int A_0)
	{
		return new ah(A_0);
	}

	public string c()
	{
		return string.Format(CultureInfo.CurrentCulture, "Red:{1} Green:{2} Blue:{3}", new object[3] { this.a, this.b, this.c });
	}

	public string a(string A_0)
	{
		if (A_0 == null)
		{
			return ToString();
		}
		return string.Format(CultureInfo.CurrentCulture, "Red:{1} Green:{2} Blue:{3}", new object[3]
		{
			this.a.ToString(A_0, CultureInfo.CurrentCulture),
			this.b.ToString(A_0, CultureInfo.CurrentCulture),
			this.c.ToString(A_0, CultureInfo.CurrentCulture)
		});
	}

	public string a(IFormatProvider A_0)
	{
		return string.Format(A_0, "Red:{1} Green:{2} Blue:{3}", new object[3] { this.a, this.b, this.c });
	}

	public string a(string A_0, IFormatProvider A_1)
	{
		if (A_0 == null)
		{
			return a(A_1);
		}
		return string.Format(A_1, "Red:{1} Green:{2} Blue:{3}", new object[3]
		{
			this.a.ToString(A_0, A_1),
			this.b.ToString(A_0, A_1),
			this.c.ToString(A_0, A_1)
		});
	}

	string IFormattable.ToString(string A_0, IFormatProvider A_1)
	{
		//ILSpy generated this explicit interface implementation from .override directive in a
		return this.a(A_0, A_1);
	}

	public int e()
	{
		return this.a.GetHashCode() + this.b.GetHashCode() + this.c.GetHashCode();
	}

	public bool f(ah A_0)
	{
		if (this.a == A_0.a && this.b == A_0.b)
		{
			return this.c == A_0.c;
		}
		return false;
	}

	bool IEquatable<ah>.Equals(ah A_0)
	{
		//ILSpy generated this explicit interface implementation from .override directive in f
		return this.f(A_0);
	}

	public bool a(object A_0)
	{
		if (A_0 == null)
		{
			return false;
		}
		if ((object)A_0.GetType() != GetType())
		{
			return false;
		}
		return f((ah)A_0);
	}
}
