using System;
using System.Globalization;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace SharpDX;

[Serializable]
[StructLayout(LayoutKind.Sequential, Pack = 4)]
[DefaultMember("Item")]
public struct h : IEquatable<h>, IFormattable
{
	public static readonly int a = Marshal.SizeOf(typeof(h));

	public static readonly h b = default(h);

	public static readonly h c = new h(1, 0, 0, 0);

	public static readonly h d = new h(0, 1, 0, 0);

	public static readonly h e = new h(0, 0, 1, 0);

	public static readonly h f = new h(0, 0, 0, 1);

	public static readonly h g = new h(1, 1, 1, 1);

	public int h;

	public int i;

	public int j;

	public int k;

	public h(int A_0)
	{
		this.h = A_0;
		this.i = A_0;
		j = A_0;
		k = A_0;
	}

	public h(int A_0, int A_1, int A_2, int A_3)
	{
		this.h = A_0;
		this.i = A_1;
		j = A_2;
		k = A_3;
	}

	public h(int[] A_0)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("values");
		}
		if (A_0.Length != 4)
		{
			throw new ArgumentOutOfRangeException("values", "There must be four and only four input values for Int4.");
		}
		this.h = A_0[0];
		this.i = A_0[1];
		j = A_0[2];
		k = A_0[3];
	}

	[SpecialName]
	public int a(int A_0)
	{
		return A_0 switch
		{
			0 => this.h, 
			1 => this.i, 
			2 => j, 
			3 => k, 
			_ => throw new ArgumentOutOfRangeException("index", "Indices for Int4 run from 0 to 3, inclusive."), 
		};
	}

	[SpecialName]
	public void a(int A_0, int A_1)
	{
		switch (A_0)
		{
		case 0:
			this.h = A_1;
			break;
		case 1:
			this.i = A_1;
			break;
		case 2:
			j = A_1;
			break;
		case 3:
			k = A_1;
			break;
		default:
			throw new ArgumentOutOfRangeException("index", "Indices for Int4 run from 0 to 3, inclusive.");
		}
	}

	public int[] a()
	{
		return new int[4] { this.h, this.i, j, k };
	}

	public static void e(ref h A_0, ref h A_1, out h A_2)
	{
		A_2 = new h(A_0.h + A_1.h, A_0.i + A_1.i, A_0.j + A_1.j, A_0.k + A_1.k);
	}

	public static h i(h A_0, h A_1)
	{
		return new h(A_0.h + A_1.h, A_0.i + A_1.i, A_0.j + A_1.j, A_0.k + A_1.k);
	}

	public static void d(ref h A_0, ref h A_1, out h A_2)
	{
		A_2 = new h(A_0.h - A_1.h, A_0.i - A_1.i, A_0.j - A_1.j, A_0.k - A_1.k);
	}

	public static h h(h A_0, h A_1)
	{
		return new h(A_0.h - A_1.h, A_0.i - A_1.i, A_0.j - A_1.j, A_0.k - A_1.k);
	}

	public static void b(ref h A_0, int A_1, out h A_2)
	{
		A_2 = new h(A_0.h * A_1, A_0.i * A_1, A_0.j * A_1, A_0.k * A_1);
	}

	public static h d(h A_0, int A_1)
	{
		return new h(A_0.h * A_1, A_0.i * A_1, A_0.j * A_1, A_0.k * A_1);
	}

	public static void c(ref h A_0, ref h A_1, out h A_2)
	{
		A_2 = new h(A_0.h * A_1.h, A_0.i * A_1.i, A_0.j * A_1.j, A_0.k * A_1.k);
	}

	public static h g(h A_0, h A_1)
	{
		return new h(A_0.h * A_1.h, A_0.i * A_1.i, A_0.j * A_1.j, A_0.k * A_1.k);
	}

	public static void a(ref h A_0, int A_1, out h A_2)
	{
		A_2 = new h(A_0.h / A_1, A_0.i / A_1, A_0.j / A_1, A_0.k / A_1);
	}

	public static h c(h A_0, int A_1)
	{
		return new h(A_0.h / A_1, A_0.i / A_1, A_0.j / A_1, A_0.k / A_1);
	}

	public static void a(ref h A_0, out h A_1)
	{
		A_1 = new h(-A_0.h, -A_0.i, -A_0.j, -A_0.k);
	}

	public static h g(h A_0)
	{
		return new h(-A_0.h, -A_0.i, -A_0.j, -A_0.k);
	}

	public static void a(ref h A_0, ref h A_1, ref h A_2, out h A_3)
	{
		int num = A_0.h;
		num = ((num > A_2.h) ? A_2.h : num);
		num = ((num < A_1.h) ? A_1.h : num);
		int num2 = A_0.i;
		num2 = ((num2 > A_2.i) ? A_2.i : num2);
		num2 = ((num2 < A_1.i) ? A_1.i : num2);
		int num3 = A_0.j;
		num3 = ((num3 > A_2.j) ? A_2.j : num3);
		num3 = ((num3 < A_1.j) ? A_1.j : num3);
		int num4 = A_0.k;
		num4 = ((num4 > A_2.k) ? A_2.k : num4);
		num4 = ((num4 < A_1.k) ? A_1.k : num4);
		A_3 = new h(num, num2, num3, num4);
	}

	public static h a(h A_0, h A_1, h A_2)
	{
		a(ref A_0, ref A_1, ref A_2, out var A_3);
		return A_3;
	}

	public static void b(ref h A_0, ref h A_1, out h A_2)
	{
		A_2.h = ((A_0.h > A_1.h) ? A_0.h : A_1.h);
		A_2.i = ((A_0.i > A_1.i) ? A_0.i : A_1.i);
		A_2.j = ((A_0.j > A_1.j) ? A_0.j : A_1.j);
		A_2.k = ((A_0.k > A_1.k) ? A_0.k : A_1.k);
	}

	public static h f(h A_0, h A_1)
	{
		b(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void a(ref h A_0, ref h A_1, out h A_2)
	{
		A_2.h = ((A_0.h < A_1.h) ? A_0.h : A_1.h);
		A_2.i = ((A_0.i < A_1.i) ? A_0.i : A_1.i);
		A_2.j = ((A_0.j < A_1.j) ? A_0.j : A_1.j);
		A_2.k = ((A_0.k < A_1.k) ? A_0.k : A_1.k);
	}

	public static h e(h A_0, h A_1)
	{
		a(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	[SpecialName]
	public static h d(h A_0, h A_1)
	{
		return new h(A_0.h + A_1.h, A_0.i + A_1.i, A_0.j + A_1.j, A_0.k + A_1.k);
	}

	[SpecialName]
	public static h f(h A_0)
	{
		return A_0;
	}

	[SpecialName]
	public static h c(h A_0, h A_1)
	{
		return new h(A_0.h - A_1.h, A_0.i - A_1.i, A_0.j - A_1.j, A_0.k - A_1.k);
	}

	[SpecialName]
	public static h e(h A_0)
	{
		return new h(-A_0.h, -A_0.i, -A_0.j, -A_0.k);
	}

	[SpecialName]
	public static h a(int A_0, h A_1)
	{
		return new h(A_1.h * A_0, A_1.i * A_0, A_1.j * A_0, A_1.k * A_0);
	}

	[SpecialName]
	public static h b(h A_0, int A_1)
	{
		return new h(A_0.h * A_1, A_0.i * A_1, A_0.j * A_1, A_0.k * A_1);
	}

	[SpecialName]
	public static h a(h A_0, int A_1)
	{
		return new h(A_0.h / A_1, A_0.i / A_1, A_0.j / A_1, A_0.k / A_1);
	}

	[SpecialName]
	public static bool b(h A_0, h A_1)
	{
		return A_0.h(A_1);
	}

	[SpecialName]
	public static bool a(h A_0, h A_1)
	{
		return !A_0.h(A_1);
	}

	[SpecialName]
	public static au d(h A_0)
	{
		return new au(A_0.h, A_0.i);
	}

	[SpecialName]
	public static a c(h A_0)
	{
		return new a(A_0.h, A_0.i, A_0.j);
	}

	[SpecialName]
	public static i b(h A_0)
	{
		return new i(A_0.h, A_0.i, A_0.j, A_0.k);
	}

	public string b()
	{
		return string.Format(CultureInfo.CurrentCulture, "X:{0} Y:{1} Z:{2} W:{3}", this.h, this.i, j, k);
	}

	public string a(string A_0)
	{
		if (A_0 == null)
		{
			return ToString();
		}
		return string.Format(CultureInfo.CurrentCulture, "X:{0} Y:{1} Z:{2} W:{3}", this.h.ToString(A_0, CultureInfo.CurrentCulture), this.i.ToString(A_0, CultureInfo.CurrentCulture), j.ToString(A_0, CultureInfo.CurrentCulture), k.ToString(A_0, CultureInfo.CurrentCulture));
	}

	public string a(IFormatProvider A_0)
	{
		return string.Format(A_0, "X:{0} Y:{1} Z:{2} W:{3}", this.h, this.i, j, k);
	}

	public string a(string A_0, IFormatProvider A_1)
	{
		if (A_0 == null)
		{
			a(A_1);
		}
		return string.Format(A_1, "X:{0} Y:{1} Z:{2} W:{3}", this.h.ToString(A_0, A_1), this.i.ToString(A_0, A_1), j.ToString(A_0, A_1), k.ToString(A_0, A_1));
	}

	string IFormattable.ToString(string A_0, IFormatProvider A_1)
	{
		//ILSpy generated this explicit interface implementation from .override directive in a
		return this.a(A_0, A_1);
	}

	public int c()
	{
		return this.h.GetHashCode() + this.i.GetHashCode() + j.GetHashCode() + k.GetHashCode();
	}

	public bool h(h A_0)
	{
		if (A_0.h == this.h && A_0.i == this.i && A_0.j == j)
		{
			return A_0.k == k;
		}
		return false;
	}

	bool IEquatable<h>.Equals(h A_0)
	{
		//ILSpy generated this explicit interface implementation from .override directive in h
		return this.h(A_0);
	}

	public bool a(object A_0)
	{
		if (A_0 == null)
		{
			return false;
		}
		if ((object)A_0.GetType() != GetType())
		{
			return false;
		}
		return h((h)A_0);
	}

	[SpecialName]
	public static h a(int[] A_0)
	{
		return new h(A_0);
	}

	[SpecialName]
	public static int[] a(h A_0)
	{
		return A_0.a();
	}
}
