using System;
using System.Globalization;
using System.Runtime.CompilerServices;

namespace SharpDX;

[Serializable]
public struct r : IComparable, IComparable<r>, IEquatable<r>, IFormattable
{
	public const float a = 0.0027777778f;

	public const float b = 4.6296296E-05f;

	public const float c = 7.7160496E-07f;

	public const float d = 1f / (2f * (float)Math.PI);

	public const float e = 0.00015915494f;

	public const float f = 0.0025f;

	private float m_g;

	public r(float A_0, e A_1)
	{
		switch (A_1)
		{
		case SharpDX.e.a:
			this.m_g = ab.j(A_0);
			break;
		case SharpDX.e.b:
			this.m_g = ab.g(A_0);
			break;
		case SharpDX.e.c:
			this.m_g = A_0;
			break;
		case SharpDX.e.d:
			this.m_g = ab.b(A_0);
			break;
		default:
			this.m_g = 0f;
			break;
		}
	}

	public r(float A_0, float A_1)
	{
		this.m_g = A_0 / A_1;
	}

	public void n()
	{
		float num = (float)Math.IEEERemainder(this.m_g, 6.2831854820251465);
		if (num <= -(float)Math.PI)
		{
			num += (float)Math.PI * 2f;
		}
		else if (num > (float)Math.PI)
		{
			num -= (float)Math.PI * 2f;
		}
		this.m_g = num;
	}

	public void x()
	{
		float num = this.m_g % ((float)Math.PI * 2f);
		if ((double)num < 0.0)
		{
			num += (float)Math.PI * 2f;
		}
		this.m_g = num;
	}

	[SpecialName]
	public float m()
	{
		return ab.f(this.m_g);
	}

	[SpecialName]
	public void b(float A_0)
	{
		this.m_g = ab.j(A_0);
	}

	[SpecialName]
	public float u()
	{
		return ab.a(this.m_g);
	}

	[SpecialName]
	public void a(float A_0)
	{
		this.m_g = ab.g(A_0);
	}

	[SpecialName]
	public float v()
	{
		float num = ab.a(this.m_g);
		if (num < 0f)
		{
			float num2 = (float)Math.Ceiling(num);
			return (num - num2) * 60f;
		}
		float num3 = (float)Math.Floor(num);
		return (num - num3) * 60f;
	}

	[SpecialName]
	public void g(float A_0)
	{
		float num = ab.a(this.m_g);
		float num2 = (float)Math.Floor(num);
		num2 += A_0 / 60f;
		this.m_g = ab.g(num2);
	}

	[SpecialName]
	public float f()
	{
		float num = ab.a(this.m_g);
		if (num < 0f)
		{
			float num2 = (float)Math.Ceiling(num);
			float num3 = (num - num2) * 60f;
			float num4 = (float)Math.Ceiling(num3);
			return (num3 - num4) * 60f;
		}
		float num5 = (float)Math.Floor(num);
		float num6 = (num - num5) * 60f;
		float num7 = (float)Math.Floor(num6);
		return (num6 - num7) * 60f;
	}

	[SpecialName]
	public void d(float A_0)
	{
		float num = ab.a(this.m_g);
		float num2 = (float)Math.Floor(num);
		float num3 = (num - num2) * 60f;
		float num4 = (float)Math.Floor(num3);
		num4 += A_0 / 60f;
		num2 += num4 / 60f;
		this.m_g = ab.g(num2);
	}

	[SpecialName]
	public float w()
	{
		return this.m_g;
	}

	[SpecialName]
	public void e(float A_0)
	{
		this.m_g = A_0;
	}

	[SpecialName]
	public float k()
	{
		return this.m_g / 0.001f;
	}

	[SpecialName]
	public void f(float A_0)
	{
		this.m_g = A_0 * 0.001f;
	}

	[SpecialName]
	public float o()
	{
		return ab.e(this.m_g);
	}

	[SpecialName]
	public void c(float A_0)
	{
		this.m_g = ab.e(A_0);
	}

	[SpecialName]
	public bool j()
	{
		return this.m_g == (float)Math.PI / 2f;
	}

	[SpecialName]
	public bool r()
	{
		return this.m_g == (float)Math.PI;
	}

	[SpecialName]
	public bool t()
	{
		return this.m_g == (float)Math.PI * 2f;
	}

	[SpecialName]
	public bool s()
	{
		return c(this).m_g != (float)Math.PI / 2f;
	}

	[SpecialName]
	public bool q()
	{
		if ((double)this.m_g > 0.0)
		{
			return this.m_g < (float)Math.PI / 2f;
		}
		return false;
	}

	[SpecialName]
	public bool i()
	{
		if (this.m_g > (float)Math.PI / 2f)
		{
			return this.m_g < (float)Math.PI;
		}
		return false;
	}

	[SpecialName]
	public bool p()
	{
		if (this.m_g > (float)Math.PI)
		{
			return this.m_g < (float)Math.PI * 2f;
		}
		return false;
	}

	[SpecialName]
	public r l()
	{
		return new r((float)Math.PI / 2f - this.m_g, SharpDX.e.c);
	}

	[SpecialName]
	public r h()
	{
		return new r((float)Math.PI - this.m_g, SharpDX.e.c);
	}

	public static r d(r A_0)
	{
		A_0.n();
		return A_0;
	}

	public static r c(r A_0)
	{
		A_0.x();
		return A_0;
	}

	public static r p(r A_0, r A_1)
	{
		if (A_0.m_g < A_1.m_g)
		{
			return A_0;
		}
		return A_1;
	}

	public static r o(r A_0, r A_1)
	{
		if (A_0.m_g > A_1.m_g)
		{
			return A_0;
		}
		return A_1;
	}

	public static r n(r A_0, r A_1)
	{
		return new r(A_0.m_g + A_1.m_g, SharpDX.e.c);
	}

	public static r m(r A_0, r A_1)
	{
		return new r(A_0.m_g - A_1.m_g, SharpDX.e.c);
	}

	public static r l(r A_0, r A_1)
	{
		return new r(A_0.m_g * A_1.m_g, SharpDX.e.c);
	}

	public static r k(r A_0, r A_1)
	{
		return new r(A_0.m_g / A_1.m_g, SharpDX.e.c);
	}

	[SpecialName]
	public static r d()
	{
		return new r(0f, SharpDX.e.c);
	}

	[SpecialName]
	public static r c()
	{
		return new r((float)Math.PI / 2f, SharpDX.e.c);
	}

	[SpecialName]
	public static r b()
	{
		return new r((float)Math.PI, SharpDX.e.c);
	}

	[SpecialName]
	public static r a()
	{
		return new r((float)Math.PI * 2f, SharpDX.e.c);
	}

	[SpecialName]
	public static bool j(r A_0, r A_1)
	{
		return A_0.m_g == A_1.m_g;
	}

	[SpecialName]
	public static bool i(r A_0, r A_1)
	{
		return A_0.m_g != A_1.m_g;
	}

	[SpecialName]
	public static bool h(r A_0, r A_1)
	{
		return A_0.m_g < A_1.m_g;
	}

	[SpecialName]
	public static bool g(r A_0, r A_1)
	{
		return A_0.m_g > A_1.m_g;
	}

	[SpecialName]
	public static bool f(r A_0, r A_1)
	{
		return A_0.m_g <= A_1.m_g;
	}

	[SpecialName]
	public static bool e(r A_0, r A_1)
	{
		return A_0.m_g >= A_1.m_g;
	}

	[SpecialName]
	public static r b(r A_0)
	{
		return A_0;
	}

	[SpecialName]
	public static r a(r A_0)
	{
		return new r(0f - A_0.m_g, SharpDX.e.c);
	}

	[SpecialName]
	public static r d(r A_0, r A_1)
	{
		return new r(A_0.m_g + A_1.m_g, SharpDX.e.c);
	}

	[SpecialName]
	public static r c(r A_0, r A_1)
	{
		return new r(A_0.m_g - A_1.m_g, SharpDX.e.c);
	}

	[SpecialName]
	public static r b(r A_0, r A_1)
	{
		return new r(A_0.m_g * A_1.m_g, SharpDX.e.c);
	}

	[SpecialName]
	public static r a(r A_0, r A_1)
	{
		return new r(A_0.m_g / A_1.m_g, SharpDX.e.c);
	}

	public int a(object A_0)
	{
		if (A_0 == null)
		{
			return 1;
		}
		if (!(A_0 is r))
		{
			throw new ArgumentException("Argument must be of type Angle.", "other");
		}
		float num = ((r)A_0).m_g;
		if (this.m_g > num)
		{
			return 1;
		}
		if (this.m_g < num)
		{
			return -1;
		}
		return 0;
	}

	int IComparable.CompareTo(object A_0)
	{
		//ILSpy generated this explicit interface implementation from .override directive in a
		return this.a(A_0);
	}

	public int e(r A_0)
	{
		if (this.m_g > A_0.m_g)
		{
			return 1;
		}
		if (this.m_g < A_0.m_g)
		{
			return -1;
		}
		return 0;
	}

	int IComparable<r>.CompareTo(r A_0)
	{
		//ILSpy generated this explicit interface implementation from .override directive in e
		return this.e(A_0);
	}

	public bool f(r A_0)
	{
		return j(this, A_0);
	}

	bool IEquatable<r>.Equals(r A_0)
	{
		//ILSpy generated this explicit interface implementation from .override directive in f
		return this.f(A_0);
	}

	public string g()
	{
		return string.Format(CultureInfo.CurrentCulture, ab.a(this.m_g).ToString("0.##°"));
	}

	public string a(string A_0)
	{
		if (A_0 == null)
		{
			return ToString();
		}
		return string.Format(CultureInfo.CurrentCulture, "{0}°", new object[1] { ab.a(this.m_g).ToString(A_0, CultureInfo.CurrentCulture) });
	}

	public string a(IFormatProvider A_0)
	{
		return string.Format(A_0, ab.a(this.m_g).ToString("0.##°"));
	}

	public string a(string A_0, IFormatProvider A_1)
	{
		if (A_0 == null)
		{
			return a(A_1);
		}
		return string.Format(A_1, "{0}°", new object[1] { ab.a(this.m_g).ToString(A_0, CultureInfo.CurrentCulture) });
	}

	string IFormattable.ToString(string A_0, IFormatProvider A_1)
	{
		//ILSpy generated this explicit interface implementation from .override directive in a
		return this.a(A_0, A_1);
	}

	public int e()
	{
		return (int)(BitConverter.DoubleToInt64Bits(this.m_g) % int.MaxValue);
	}

	public bool b(object A_0)
	{
		if (A_0 is r)
		{
			return j(this, (r)A_0);
		}
		return false;
	}
}
