using System;
using System.IO;

namespace Com.Raritan.Core.Impl;

public class e
{
	private const int m_a = 65536;

	private Stream m_b;

	private int m_c;

	private int m_d;

	private byte[] m_e;

	private int m_f;

	private int m_g;

	private object m_h;

	private bool m_i;

	public e(Stream A_0, bool A_1)
	{
		this.m_b = A_0;
		this.m_i = A_1;
		this.m_c = 65536;
		this.m_e = new byte[this.m_c];
		this.m_d = 0;
		this.m_f = 0;
		this.m_g = 0;
		this.m_h = new object();
	}

	public void e()
	{
		if (this.m_i && this.m_b != null)
		{
			this.m_b.Close();
		}
	}

	private int a()
	{
		if (this.m_d - this.m_f <= 0)
		{
			return this.m_b.ReadByte();
		}
		return this.m_e[this.m_f++] & 0xFF;
	}

	private int a(byte[] A_0, int A_1, int A_2)
	{
		int num = this.m_d - this.m_f;
		if (num <= 0)
		{
			return this.m_b.Read(A_0, A_1, A_2);
		}
		int num2 = Math.Min(A_2, num);
		Array.Copy(this.m_e, this.m_f, A_0, A_1, num2);
		this.m_f += num2;
		return num2;
	}

	public void c(byte[] A_0, int A_1, int A_2)
	{
		if (A_2 == 0)
		{
			return;
		}
		lock (this.m_h)
		{
			if (this.m_g - A_2 > 0)
			{
				this.m_g -= A_2;
			}
			else
			{
				this.m_g = 0;
			}
		}
		int num = this.m_d - this.m_f;
		if (num > 0)
		{
			if (num + A_2 > this.m_c)
			{
				this.m_c = num + A_2;
				byte[] destinationArray = new byte[this.m_c];
				Array.Copy(this.m_e, this.m_f, destinationArray, A_2, num);
				this.m_e = destinationArray;
			}
			else
			{
				Array.Copy(this.m_e, this.m_f, this.m_e, A_2, num);
			}
		}
		this.m_f = 0;
		this.m_d = num + A_2;
		Array.Copy(A_0, A_1, this.m_e, this.m_f, A_2);
	}

	public int b(byte[] A_0)
	{
		return d(A_0, 0, A_0.Length);
	}

	public int d(byte[] A_0, int A_1, int A_2)
	{
		int num = a(A_0, A_1, A_2);
		lock (this.m_h)
		{
			this.m_g += num;
			return num;
		}
	}

	public int h()
	{
		int result = a();
		lock (this.m_h)
		{
			this.m_g++;
			return result;
		}
	}

	public void a(byte[] A_0)
	{
		b(A_0, 0, A_0.Length);
	}

	public void b(byte[] A_0, int A_1, int A_2)
	{
		if (A_2 < 0)
		{
			throw new ArgumentException();
		}
		int num2;
		for (int num = 0; num < A_2; num += num2)
		{
			num2 = a(A_0, A_1 + num, A_2 - num);
			if (num2 < 0)
			{
				throw new EndOfStreamException();
			}
		}
		lock (this.m_h)
		{
			this.m_g += A_2;
		}
	}

	public bool c()
	{
		int num = a();
		if (num < 0)
		{
			throw new EndOfStreamException();
		}
		lock (this.m_h)
		{
			this.m_g++;
		}
		return num != 0;
	}

	public byte k()
	{
		int num = a();
		if (num < 0)
		{
			throw new EndOfStreamException();
		}
		lock (this.m_h)
		{
			this.m_g++;
		}
		return (byte)num;
	}

	public short m()
	{
		int num = a();
		int num2 = a();
		if ((num | num2) < 0)
		{
			throw new EndOfStreamException();
		}
		lock (this.m_h)
		{
			this.m_g += 2;
		}
		return (short)((num << 8) | num2);
	}

	public ushort f()
	{
		int num = a();
		int num2 = a();
		if ((num | num2) < 0)
		{
			throw new EndOfStreamException();
		}
		lock (this.m_h)
		{
			this.m_g += 2;
		}
		return (ushort)((num << 8) | num2);
	}

	public char l()
	{
		int num = a();
		int num2 = a();
		if ((num | num2) < 0)
		{
			throw new EndOfStreamException();
		}
		lock (this.m_h)
		{
			this.m_g += 2;
		}
		return (char)((num << 8) | num2);
	}

	public int b()
	{
		int num = a();
		int num2 = a();
		int num3 = a();
		int num4 = a();
		if ((num | num2 | num3 | num4) < 0)
		{
			throw new EndOfStreamException();
		}
		lock (this.m_h)
		{
			this.m_g += 4;
		}
		return (num << 24) | (num2 << 16) | (num3 << 8) | num4;
	}

	public uint j()
	{
		int num = a();
		int num2 = a();
		int num3 = a();
		int num4 = a();
		if ((num | num2 | num3 | num4) < 0)
		{
			throw new EndOfStreamException();
		}
		lock (this.m_h)
		{
			this.m_g += 4;
		}
		return (uint)((num << 24) | (num2 << 16) | (num3 << 8) | num4);
	}

	public long i()
	{
		long num = a();
		long num2 = a();
		long num3 = a();
		long num4 = a();
		long num5 = a();
		long num6 = a();
		long num7 = a();
		long num8 = a();
		if ((num | num2 | num3 | num4 | num5 | num6 | num7 | num8) < 0)
		{
			throw new EndOfStreamException();
		}
		lock (this.m_h)
		{
			this.m_g += 8;
		}
		return (num << 56) | (num2 << 48) | (num3 << 40) | (num4 << 32) | (num5 << 24) | (num6 << 16) | (num7 << 8) | num8;
	}

	public ulong d()
	{
		long num = a();
		long num2 = a();
		long num3 = a();
		long num4 = a();
		long num5 = a();
		long num6 = a();
		long num7 = a();
		long num8 = a();
		if ((num | num2 | num3 | num4 | num5 | num6 | num7 | num8) < 0)
		{
			throw new EndOfStreamException();
		}
		lock (this.m_h)
		{
			this.m_g += 8;
		}
		return (ulong)((num << 56) | (num2 << 48) | (num3 << 40) | (num4 << 32) | (num5 << 24) | (num6 << 16) | (num7 << 8) | num8);
	}

	public string g()
	{
		int num = f();
		byte[] a_ = new byte[num];
		a(a_);
		return Com.Raritan.Core.Impl.f.a(a_);
	}

	public string a(int A_0)
	{
		byte[] a_ = new byte[A_0];
		a(a_);
		return Com.Raritan.Core.Impl.f.b(a_);
	}

	public int n()
	{
		lock (this.m_h)
		{
			int result = this.m_g;
			this.m_g = 0;
			return result;
		}
	}
}
