using System;
using System.Reflection;
using System.Security.Cryptography;
using log4net;

namespace Com.Raritan.Core.Impl;

public class i
{
	public enum b
	{
		a,
		b,
		c,
		d
	}

	private struct a
	{
		public readonly b a;

		public readonly string[] b;

		public a(b A_0, string[] A_1)
		{
			a = A_0;
			b = A_1;
		}
	}

	private readonly a[] m_a = new a[4]
	{
		new a(i.b.a, new string[2] { "System.Security.Cryptography.MD5CryptoServiceProvider", "System.Security.Cryptography.MD5Cng" }),
		new a(i.b.b, new string[3] { "System.Security.Cryptography.SHA1Managed", "System.Security.Cryptography.SHA1CryptoServiceProvider", "System.Security.Cryptography.SHA1Cng" }),
		new a(i.b.c, new string[3] { "System.Security.Cryptography.SHA256Managed", "System.Security.Cryptography.SHA256CryptoServiceProvider", "System.Security.Cryptography.SHA256Cng" }),
		new a(i.b.d, new string[3] { "System.Security.Cryptography.SHA512Managed", "System.Security.Cryptography.SHA512CryptoServiceProvider", "System.Security.Cryptography.SHA512Cng" })
	};

	private readonly Assembly m_b;

	private readonly ILog c;

	public i(ILog A_0)
	{
		c = A_0;
		try
		{
			this.m_b = Assembly.Load("System.Core, Version=3.5.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089");
		}
		catch
		{
			this.m_b = null;
		}
	}

	public HashAlgorithm a(b A_0)
	{
		a[] array = this.m_a;
		for (int num = 0; num < array.Length; num++)
		{
			a a2 = array[num];
			if (a2.a != A_0)
			{
				continue;
			}
			string[] array2 = a2.b;
			foreach (string a_ in array2)
			{
				HashAlgorithm hashAlgorithm = a(a_);
				if (hashAlgorithm != null)
				{
					return hashAlgorithm;
				}
			}
		}
		return null;
	}

	private HashAlgorithm a(string A_0)
	{
		c.DebugFormat("Loading digest class \"{0}\"", A_0);
		Type type = Type.GetType(A_0);
		if ((object)type != null)
		{
			c.Debug("Found digest in mscorelib.dll");
		}
		else if ((object)this.m_b != null && (object)(type = this.m_b.GetType(A_0)) != null)
		{
			c.Debug("Found digest in System.Core.dll");
		}
		if ((object)type == null)
		{
			c.InfoFormat("Digest class \"{0}\" not found!", A_0);
			return null;
		}
		try
		{
			return Activator.CreateInstance(type) as HashAlgorithm;
		}
		catch (Exception exception)
		{
			c.Info($"Could not instanciate Digest class \"{A_0}\"", exception);
			return null;
		}
	}
}
