using System;
using System.Collections.Generic;
using System.Net;
using System.Net.NetworkInformation;
using System.Net.Sockets;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading;
using log4net;

namespace Com.Raritan.KxGui.FavoriteDevices;

public class b
{
	internal delegate void b(d A_0);

	private delegate Dictionary<string, string> a(Dictionary<string, Dictionary<string, string>> A_0);

	internal class d
	{
		private readonly c m_a;

		private readonly byte[] m_b;

		private readonly Socket m_c;

		private readonly Dictionary<string, Dictionary<string, string>> m_d;

		private readonly b m_e;

		public d(c A_0, byte[] A_1, Socket A_2, b A_3)
		{
			this.m_a = A_0;
			this.m_e = A_3;
			this.m_b = A_1;
			this.m_c = A_2;
			this.m_d = new Dictionary<string, Dictionary<string, string>>();
		}

		[SpecialName]
		public b d()
		{
			return this.m_e;
		}

		[SpecialName]
		public c a()
		{
			return this.m_a;
		}

		[SpecialName]
		public Dictionary<string, Dictionary<string, string>> f()
		{
			return this.m_d;
		}

		[SpecialName]
		public byte[] b()
		{
			return this.m_b;
		}

		[SpecialName]
		public Socket e()
		{
			return this.m_c;
		}

		[SpecialName]
		public EndPoint c()
		{
			if (e().AddressFamily == AddressFamily.InterNetworkV6)
			{
				return new IPEndPoint(IPAddress.IPv6Any, 0);
			}
			return new IPEndPoint(IPAddress.Any, 0);
		}
	}

	internal class c
	{
		private volatile bool m_a;

		[SpecialName]
		public bool a()
		{
			return this.m_a;
		}

		public void a(object A_0)
		{
			this.m_a = true;
		}
	}

	private static int m_b = 100000;

	private static readonly ILog m_c = LogManager.GetLogger(typeof(Com.Raritan.KxGui.FavoriteDevices.b));

	private static readonly l e = new l();

	private static byte[] m_d = new byte[20]
	{
		0,
		0,
		0,
		20,
		Convert.ToByte('<'),
		Convert.ToByte('C'),
		Convert.ToByte('S'),
		Convert.ToByte('C'),
		Convert.ToByte('_'),
		Convert.ToByte('D'),
		Convert.ToByte('i'),
		Convert.ToByte('s'),
		Convert.ToByte('c'),
		Convert.ToByte('o'),
		Convert.ToByte('v'),
		Convert.ToByte('e'),
		Convert.ToByte('r'),
		Convert.ToByte('/'),
		Convert.ToByte('>'),
		0
	};

	private static List<IPAddress> m_a;

	private static IPAddress f = new IPAddress(new byte[4] { 255, 255, 255, 255 });

	private static int g = 15000;

	private static string h;

	[CompilerGenerated]
	private static a i;

	public static string a(string A_0, int A_1)
	{
		Com.Raritan.KxGui.FavoriteDevices.b.m_c.Info("Starting Discovery on: " + A_0);
		string uriString = ((string.IsNullOrEmpty(A_0) || A_0.IndexOf(":") <= 0) ? ("https://" + A_0 + ":" + A_1 + "/webs_discovery.asp") : ("https://[" + A_0 + "]:" + A_1 + "/webs_discovery.asp"));
		Uri a_;
		try
		{
			a_ = new Uri(uriString);
		}
		catch (Exception exception)
		{
			string message = "Exception on parsing the url";
			Com.Raritan.KxGui.FavoriteDevices.b.m_c.Error(message, exception);
			throw new Exception(message);
		}
		string text = null;
		try
		{
			text = e.a(a_, null);
		}
		catch (TimeoutException exception2)
		{
			string message2 = "Timeout occured on connecting to device: " + A_0;
			Com.Raritan.KxGui.FavoriteDevices.b.m_c.Error(message2, exception2);
			throw new Exception(message2);
		}
		catch (Exception exception3)
		{
			string message3 = "Exception occured on connecting to device: " + A_0;
			Com.Raritan.KxGui.FavoriteDevices.b.m_c.Error(message3, exception3);
			throw new Exception(message3);
		}
		Com.Raritan.KxGui.FavoriteDevices.b.m_c.Debug("HTTPSGetResponse : " + text);
		if (text == null)
		{
			string message4 = "Failed to GETResponse from device: " + A_0;
			Com.Raritan.KxGui.FavoriteDevices.b.m_c.Error(message4);
			throw new Exception(message4);
		}
		return text;
	}

	public static Dictionary<string, Dictionary<string, string>> c(int A_0)
	{
		Socket socket = a(A_0);
		List<Socket> list = b(A_0);
		c c2 = new c();
		Timer timer = new Timer(c2.a, null, g, -1);
		IAsyncResult asyncResult = null;
		List<IAsyncResult> list2 = null;
		if (socket != null)
		{
			asyncResult = a(socket, c2);
		}
		if (list.Count > 0)
		{
			list2 = new List<IAsyncResult>();
			foreach (Socket item in list)
			{
				list2.Add(a(item, c2));
			}
		}
		Dictionary<string, Dictionary<string, string>> dictionary = null;
		Dictionary<string, Dictionary<string, string>> dictionary2 = null;
		if (asyncResult != null)
		{
			dictionary = a(asyncResult);
		}
		if (list2 != null)
		{
			List<Dictionary<string, Dictionary<string, string>>> list3 = new List<Dictionary<string, Dictionary<string, string>>>();
			foreach (IAsyncResult item2 in list2)
			{
				list3.Add(a(item2));
			}
			dictionary2 = new Dictionary<string, Dictionary<string, string>>();
			foreach (Dictionary<string, Dictionary<string, string>> item3 in list3)
			{
				foreach (KeyValuePair<string, Dictionary<string, string>> item4 in item3)
				{
					if (!dictionary2.ContainsKey(item4.Key))
					{
						dictionary2.Add(item4.Key, item4.Value);
					}
				}
			}
		}
		timer.Dispose();
		if (dictionary == null && dictionary2 == null)
		{
			return new Dictionary<string, Dictionary<string, string>>();
		}
		if (dictionary2 != null && dictionary != null)
		{
			return a(dictionary2, dictionary);
		}
		if (dictionary != null)
		{
			return dictionary;
		}
		return dictionary2;
	}

	private static Dictionary<string, Dictionary<string, string>> a(Dictionary<string, Dictionary<string, string>> A_0, Dictionary<string, Dictionary<string, string>> A_1)
	{
		a a2 = delegate(Dictionary<string, Dictionary<string, string>> A_0)
		{
			Dictionary<string, string> dictionary = new Dictionary<string, string>();
			h = "Device.id";
			foreach (KeyValuePair<string, Dictionary<string, string>> item in A_0)
			{
				if (item.Value.ContainsKey(h) && !dictionary.ContainsKey(item.Value[h]))
				{
					dictionary.Add(item.Value[h], item.Key);
				}
			}
			return dictionary;
		};
		Dictionary<string, string> dictionary2 = a2(A_0);
		Dictionary<string, string> dictionary3 = a2(A_1);
		foreach (KeyValuePair<string, string> item2 in dictionary2)
		{
			if (dictionary3.ContainsKey(item2.Key))
			{
				A_1.Remove(dictionary3[item2.Key]);
			}
		}
		foreach (KeyValuePair<string, Dictionary<string, string>> item3 in A_1)
		{
			A_0.Add(item3.Key, item3.Value);
		}
		return A_0;
	}

	private static Dictionary<string, Dictionary<string, string>> a(IAsyncResult A_0)
	{
		d d = (d)A_0.AsyncState;
		try
		{
			A_0.AsyncWaitHandle.WaitOne();
			return d.f();
		}
		catch (Exception exception)
		{
			Com.Raritan.KxGui.FavoriteDevices.b.m_c.Error("Error on gathering discovery packets", exception);
		}
		finally
		{
			a(d.e());
			d.d().EndInvoke(A_0);
		}
		return new Dictionary<string, Dictionary<string, string>>();
	}

	private static IAsyncResult a(Socket A_0, c A_1)
	{
		b b2 = a;
		d d = new d(A_1, new byte[2048], A_0, b2);
		return b2.BeginInvoke(d, null, d);
	}

	private static void a(d A_0)
	{
		EndPoint remoteEP = A_0.c();
		try
		{
			int num;
			try
			{
				num = A_0.e().ReceiveFrom(A_0.b(), ref remoteEP);
			}
			catch (SocketException ex)
			{
				if (ex.ErrorCode == 10060)
				{
					if (!A_0.a().a())
					{
						a(A_0);
					}
					return;
				}
				throw ex;
			}
			if (num > 4)
			{
				string @string = Encoding.ASCII.GetString(A_0.b(), 4, num - 4);
				IPAddress address = ((IPEndPoint)remoteEP).Address;
				if (address != null)
				{
					Dictionary<string, string> dictionary = Com.Raritan.KxGui.FavoriteDevices.c.a(@string);
					string text = null;
					if (dictionary != null)
					{
						if (address.IsIPv6LinkLocal)
						{
							if (dictionary.ContainsKey("Device.IPAddress_v6"))
							{
								text = dictionary["Device.IPAddress_v6"];
							}
						}
						else
						{
							text = address.ToString();
						}
						if (text != null && !A_0.f().ContainsKey(text))
						{
							A_0.f().Add(text, dictionary);
						}
					}
				}
			}
			a(A_0);
		}
		catch (Exception exception)
		{
			Com.Raritan.KxGui.FavoriteDevices.b.m_c.Error("Exception on receiving Discovery Reply", exception);
		}
	}

	private static List<Socket> b(int A_0)
	{
		List<Socket> list = new List<Socket>();
		if (Socket.OSSupportsIPv6)
		{
			if (Com.Raritan.KxGui.FavoriteDevices.b.m_a == null)
			{
				Com.Raritan.KxGui.FavoriteDevices.b.m_a = a();
				foreach (IPAddress item in Com.Raritan.KxGui.FavoriteDevices.b.m_a)
				{
					Com.Raritan.KxGui.FavoriteDevices.b.m_c.Debug("Multicast Address : " + item);
				}
			}
			List<Socket> list2 = new List<Socket>();
			for (int i = 0; i < Com.Raritan.KxGui.FavoriteDevices.b.m_a.Count; i++)
			{
				try
				{
					list2.Add(new Socket(AddressFamily.InterNetworkV6, SocketType.Dgram, ProtocolType.Udp));
				}
				catch (SocketException exception)
				{
					Com.Raritan.KxGui.FavoriteDevices.b.m_c.Error("Failure to create ipv6 socket", exception);
					foreach (Socket item2 in list2)
					{
						a(item2);
					}
					return list;
				}
			}
			for (int j = 0; j < Com.Raritan.KxGui.FavoriteDevices.b.m_a.Count; j++)
			{
				Socket socket = list2[j];
				try
				{
					socket.Bind(new IPEndPoint(IPAddress.IPv6Any, 0));
					socket.SetSocketOption(SocketOptionLevel.IPv6, SocketOptionName.PacketInformation, optionValue: true);
					socket.SendTo(Com.Raritan.KxGui.FavoriteDevices.b.m_d, new IPEndPoint(Com.Raritan.KxGui.FavoriteDevices.b.m_a[j], A_0));
					socket.ReceiveBufferSize = Com.Raritan.KxGui.FavoriteDevices.b.m_b;
					socket.ReceiveTimeout = 1000;
					list.Add(socket);
				}
				catch (SocketException exception2)
				{
					Com.Raritan.KxGui.FavoriteDevices.b.m_c.Error("Failure on socket communication", exception2);
					a(socket);
				}
			}
		}
		return list;
	}

	private static Socket a(int A_0)
	{
		Socket socket;
		try
		{
			socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
		}
		catch (SocketException exception)
		{
			Com.Raritan.KxGui.FavoriteDevices.b.m_c.Error("Failure to create ipv4 socket", exception);
			return null;
		}
		try
		{
			socket.Bind(new IPEndPoint(IPAddress.Any, 0));
			socket.SetSocketOption(SocketOptionLevel.IP, SocketOptionName.PacketInformation, optionValue: true);
			socket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, optionValue: true);
			socket.SendTo(Com.Raritan.KxGui.FavoriteDevices.b.m_d, new IPEndPoint(f, A_0));
			socket.ReceiveBufferSize = Com.Raritan.KxGui.FavoriteDevices.b.m_b;
			socket.ReceiveTimeout = 1000;
			return socket;
		}
		catch (SocketException exception2)
		{
			Com.Raritan.KxGui.FavoriteDevices.b.m_c.Error("Failure on socket communication", exception2);
			a(socket);
			return null;
		}
	}

	private static void a(Socket A_0)
	{
		if (A_0 != null)
		{
			try
			{
				A_0.Shutdown(SocketShutdown.Both);
			}
			catch (SocketException)
			{
			}
			A_0.Close();
		}
	}

	private static List<IPAddress> a()
	{
		List<IPAddress> list = new List<IPAddress>();
		try
		{
			NetworkInterface[] allNetworkInterfaces = NetworkInterface.GetAllNetworkInterfaces();
			foreach (NetworkInterface networkInterface in allNetworkInterfaces)
			{
				if (networkInterface.NetworkInterfaceType != NetworkInterfaceType.Loopback && networkInterface.Supports(NetworkInterfaceComponent.IPv6) && networkInterface.OperationalStatus == OperationalStatus.Up)
				{
					list.Add(new IPAddress(new byte[16]
					{
						255, 2, 0, 0, 0, 0, 0, 0, 0, 0,
						0, 0, 0, 0, 0, 1
					}, networkInterface.GetIPProperties().GetIPv6Properties().Index));
				}
			}
		}
		catch (Exception exception)
		{
			Com.Raritan.KxGui.FavoriteDevices.b.m_c.Error("Exception on building Multicast address", exception);
			list = new List<IPAddress>();
		}
		return list;
	}

	[CompilerGenerated]
	private static Dictionary<string, string> a(Dictionary<string, Dictionary<string, string>> A_0)
	{
		Dictionary<string, string> dictionary = new Dictionary<string, string>();
		h = "Device.id";
		foreach (KeyValuePair<string, Dictionary<string, string>> item in A_0)
		{
			if (item.Value.ContainsKey(h) && !dictionary.ContainsKey(item.Value[h]))
			{
				dictionary.Add(item.Value[h], item.Key);
			}
		}
		return dictionary;
	}
}
