using System;
using System.Collections;
using System.Collections.Generic;
using System.Net;
using System.Net.NetworkInformation;
using System.Net.Sockets;
using System.Runtime.CompilerServices;
using System.Text;
using System.Xml;
using Com.Raritan.KxGui.Preferences;
using log4net;

namespace Com.Raritan.KxGui.FavoriteDevices;

internal static class c
{
	internal class a
	{
		[CompilerGenerated]
		private string m_a;

		[CompilerGenerated]
		private string m_b;

		[CompilerGenerated]
		private string m_c;

		[CompilerGenerated]
		private string m_d;

		[SpecialName]
		[CompilerGenerated]
		public string a()
		{
			return this.m_a;
		}

		[SpecialName]
		[CompilerGenerated]
		private void d(string A_0)
		{
			this.m_a = A_0;
		}

		[SpecialName]
		[CompilerGenerated]
		public string d()
		{
			return this.m_b;
		}

		[SpecialName]
		[CompilerGenerated]
		private void c(string A_0)
		{
			this.m_b = A_0;
		}

		[SpecialName]
		[CompilerGenerated]
		public string c()
		{
			return this.m_c;
		}

		[SpecialName]
		[CompilerGenerated]
		private void b(string A_0)
		{
			this.m_c = A_0;
		}

		[SpecialName]
		[CompilerGenerated]
		public string b()
		{
			return this.m_d;
		}

		[SpecialName]
		[CompilerGenerated]
		private void a(string A_0)
		{
			this.m_d = A_0;
		}

		public a(string A_0, string A_1, string A_2, string A_3)
		{
			d(A_0);
			c(A_1);
			b(A_2);
			a(A_3);
		}
	}

	internal const string a = "Device.Hostname";

	internal const string b = "Device.IPAddress";

	internal const string o = "Device.IPAddress_v6";

	internal const string c = "Device.Name";

	internal const string d = "Device.Model";

	internal const string p = "Device.id";

	private static ILog e = LogManager.GetLogger(typeof(c));

	internal static string f = "\u001e";

	internal static string g = "\u001d";

	internal static int h = 0;

	internal static int i = 1;

	internal static int j = 2;

	internal static string k = "CANNOT_BE_RESOLVED";

	[CompilerGenerated]
	private static Comparison<a> l;

	[CompilerGenerated]
	private static Comparison<a> m;

	[CompilerGenerated]
	private static Comparison<a> n;

	internal static Dictionary<string, string> a(string A_0)
	{
		//IL_0006: Unknown result type (might be due to invalid IL or missing references)
		//IL_000c: Expected O, but got Unknown
		//IL_0016: Expected O, but got Unknown
		//IL_0053: Unknown result type (might be due to invalid IL or missing references)
		//IL_005a: Expected O, but got Unknown
		Dictionary<string, string> dictionary = new Dictionary<string, string>();
		XmlDocument val = new XmlDocument();
		try
		{
			val.LoadXml(A_0);
		}
		catch (XmlException val2)
		{
			XmlException exception = val2;
			e.Error("Error parsing kx CSC_Info params", (Exception)(object)exception);
			return null;
		}
		XmlNode val3 = ((XmlNode)val).SelectSingleNode("CSC_Info/Device");
		if (val3 != null)
		{
			foreach (XmlAttribute item in (XmlNamedNodeMap)val3.Attributes)
			{
				XmlAttribute val4 = item;
				dictionary.Add("Device." + ((XmlNode)val4).Name, ((XmlNode)val4).Value);
			}
		}
		val3 = ((XmlNode)val).SelectSingleNode("CSC_Info/Device/Name");
		if (val3 != null)
		{
			dictionary.Add("Device.Name", val3.InnerText);
		}
		val3 = ((XmlNode)val).SelectSingleNode("CSC_Info/Device/Hostname");
		if (val3 != null)
		{
			dictionary.Add("Device.Hostname", val3.InnerText);
		}
		val3 = ((XmlNode)val).SelectSingleNode("CSC_Info/Device/IPAddress");
		if (val3 != null)
		{
			dictionary.Add("Device.IPAddress", val3.InnerText);
		}
		val3 = ((XmlNode)val).SelectSingleNode("CSC_Info/Device/IPAddress_v6");
		if (val3 != null)
		{
			dictionary.Add("Device.IPAddress_v6", val3.InnerText);
		}
		return dictionary;
	}

	internal static string b(Hashtable A_0, int A_1)
	{
		string[] array = new string[5];
		if (A_0 != null && A_0.Count > 0)
		{
			try
			{
				int count = A_0.Count;
				string[] array2 = new string[count];
				string[] array3 = new string[count];
				string[] array4 = new string[count];
				string[] array5 = new string[count];
				a[] array6 = a(A_0, A_1);
				if (array6 != null)
				{
					for (int i = 0; i < count; i++)
					{
						array5[i] = array6[i].a();
					}
					for (int j = 0; j < count; j++)
					{
						if (array6[j].b() != Com.Raritan.KxGui.FavoriteDevices.c.k)
						{
							array2[j] = array6[j].b();
						}
					}
					for (int k = 0; k < count; k++)
					{
						if (array6[k].d() != Com.Raritan.KxGui.FavoriteDevices.c.k)
						{
							array3[k] = array6[k].d();
						}
					}
					for (int l = 0; l < count; l++)
					{
						if (array6[l].c() != Com.Raritan.KxGui.FavoriteDevices.c.k)
						{
							array4[l] = array6[l].c();
						}
					}
					array[0] = a(array3, f);
					array[1] = a(array2, f);
					array[2] = a(array4, f);
					array[3] = a(array5, f);
					array[4] = A_1.ToString();
					return a(array, g);
				}
			}
			catch (Exception ex)
			{
				e.Error("BuildDeviceShowList failed: " + ex.Message);
			}
		}
		return "";
	}

	internal static a[] a(Hashtable A_0, int A_1)
	{
		if (A_0 == null)
		{
			return null;
		}
		a[] array = new a[A_0.Count];
		IDictionaryEnumerator enumerator = A_0.GetEnumerator();
		int num = 0;
		while (enumerator.MoveNext())
		{
			DevicePreferences devicePreferences = (DevicePreferences)enumerator.Value;
			array[num] = new a((string)enumerator.Key, devicePreferences.IpAddress, devicePreferences.DnsName, devicePreferences.Description);
			num++;
		}
		if (A_1 == i)
		{
			Array.Sort(array, (a A_0, a A_1) => A_0.d().CompareTo(A_1.d()));
		}
		else if (A_1 == j)
		{
			Array.Sort(array, (a A_0, a A_1) => (A_0.c() != null && A_1.c() != null) ? A_0.c().CompareTo(A_1.c()) : 0);
		}
		else
		{
			Array.Sort(array, (a A_0, a A_1) => A_0.b().CompareTo(A_1.b()));
		}
		return array;
	}

	internal static string a(string[] A_0, string A_1)
	{
		StringBuilder stringBuilder = new StringBuilder();
		if (A_0.Length > 0)
		{
			stringBuilder.Append(A_0[0]);
		}
		for (int i = 1; i < A_0.Length; i++)
		{
			stringBuilder.Append(A_1);
			stringBuilder.Append(A_0[i]);
		}
		return stringBuilder.ToString();
	}

	internal static DevicePreferences a(string A_0, Dictionary<string, string> A_1, List<DevicePreferences> A_2)
	{
		if (string.IsNullOrEmpty(A_0))
		{
			return null;
		}
		string text = null;
		string text2 = null;
		string text3 = null;
		string productType = null;
		if (A_1 != null)
		{
			foreach (KeyValuePair<string, string> item in A_1)
			{
				switch (item.Key)
				{
				case "Device.Model":
				{
					string text4 = item.Value;
					int num = 0;
					if (item.Value.IndexOf("DKX2-101") < 0)
					{
						num = item.Value.IndexOf("-");
						if (num > 0)
						{
							text4 = item.Value.Substring(0, num);
						}
					}
					productType = text4 switch
					{
						"DKX2" => "Dominion KX G2", 
						"DKX" => "Dominion KX G1", 
						"DKSX2" => "Dominion KSX G2", 
						"DKSX" => "Dominion KSX G1", 
						"DKX2-101-V2" => "KX101 G2", 
						"DKX2-101" => "KX101 G1", 
						"DLX" => "Dominion LX", 
						"IP-Reach" => "IP-Reach", 
						"USTIP" => "UST-IP G1", 
						_ => text4, 
					};
					break;
				}
				case "Device.Name":
					text3 = item.Value;
					break;
				case "Device.Hostname":
					text = item.Value;
					break;
				}
			}
			text2 = A_0;
			IPAddress iPAddress = null;
			if (!string.IsNullOrEmpty(text2))
			{
				try
				{
					iPAddress = IPAddress.Parse(text2);
				}
				catch (Exception)
				{
				}
			}
			if (iPAddress != null && iPAddress.IsIPv6LinkLocal && A_1.ContainsKey("Device.IPAddress_v6"))
			{
				text2 = A_1["Device.IPAddress_v6"];
			}
		}
		if (!string.IsNullOrEmpty(text3) && !string.IsNullOrEmpty(text2))
		{
			DevicePreferences devicePreferences = new DevicePreferences(null, null, null, null, text2, text3, text, productType, null, connectPlaybackDevice: true, null, null, 400, connectCaptureDevice: false, null, null, 400);
			if (string.IsNullOrEmpty(text))
			{
				A_2.Add(devicePreferences);
			}
			return devicePreferences;
		}
		e.Error("Cannot find device name from CSC Info");
		return null;
	}

	internal static bool a()
	{
		NetworkInterface[] allNetworkInterfaces = NetworkInterface.GetAllNetworkInterfaces();
		NetworkInterface[] array = allNetworkInterfaces;
		foreach (NetworkInterface networkInterface in array)
		{
			if (!networkInterface.NetworkInterfaceType.ToString().Contains("Ethernet") && !networkInterface.NetworkInterfaceType.ToString().Contains("Wireless"))
			{
				continue;
			}
			foreach (UnicastIPAddressInformation unicastAddress in networkInterface.GetIPProperties().UnicastAddresses)
			{
				if (unicastAddress.Address.AddressFamily == AddressFamily.InterNetworkV6 && !unicastAddress.Address.IsIPv6LinkLocal && !unicastAddress.Address.IsIPv6SiteLocal && !unicastAddress.Address.IsIPv6Multicast)
				{
					return true;
				}
			}
		}
		return false;
	}

	[CompilerGenerated]
	private static int c(a A_0, a A_1)
	{
		return A_0.d().CompareTo(A_1.d());
	}

	[CompilerGenerated]
	private static int b(a A_0, a A_1)
	{
		if (A_0.c() != null && A_1.c() != null)
		{
			return A_0.c().CompareTo(A_1.c());
		}
		return 0;
	}

	[CompilerGenerated]
	private static int a(a A_0, a A_1)
	{
		return A_0.b().CompareTo(A_1.b());
	}
}
