using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using System.Xml;
using Com.Raritan.KxGui.FavoriteDevices;
using Com.Raritan.KxGui.Preferences;
using Com.Raritan.KxGui.Scan;
using Com.Raritan.RcCore;
using log4net;

namespace Com.Raritan.KxGui;

[ComVisible(true)]
public class BrowserMediator
{
	[CompilerGenerated]
	private sealed class a
	{
		public string a;

		public bool a(Com.Raritan.RcCore.a A_0)
		{
			return A_0.PortNo.Equals(this.a);
		}
	}

	private readonly WebBrowser m_a;

	private readonly k m_b;

	private static readonly ILog m_c = LogManager.GetLogger(typeof(BrowserMediator));

	private readonly Com.Raritan.KxGui.FavoriteDevices.a m_d;

	private readonly ApplicationPreferencesManager m_e;

	private readonly DevicePreferencesManager m_f;

	private Com.Raritan.KxGui.Scan.g m_g;

	[CompilerGenerated]
	private static Func<string, int> m_h;

	[CompilerGenerated]
	private static Func<string, int> m_i;

	[CompilerGenerated]
	private static Func<string, int> j;

	[CompilerGenerated]
	private static Func<string, int> k;

	[CompilerGenerated]
	private static Func<string, int> l;

	[CompilerGenerated]
	private static Func<string, int> m;

	internal BrowserMediator(WebBrowser A_0, Com.Raritan.KxGui.FavoriteDevices.a A_1, k A_2, ApplicationPreferencesManager A_3, DevicePreferencesManager A_4)
	{
		this.m_a = A_0;
		this.m_b = A_2;
		this.m_d = A_1;
		this.m_e = A_3;
		this.m_f = A_4;
	}

	private void a(string A_0, string A_1, object[] A_2)
	{
		try
		{
			HtmlDocument val = ((A_1 == null) ? this.m_a.Document : this.m_a.Document.Window.Frames[A_1].Document);
			val.InvokeScript(A_0, A_2);
		}
		catch
		{
		}
	}

	private void a(string A_0, object[] A_1)
	{
		a(A_0, null, A_1);
	}

	private void b(string A_0, string A_1)
	{
		try
		{
			HtmlDocument val = ((A_1 == null) ? this.m_a.Document : this.m_a.Document.Window.Frames[A_1].Document);
			val.InvokeScript(A_0);
		}
		catch
		{
		}
	}

	private void c(string A_0)
	{
		b(A_0, null);
	}

	public void Init(string parameters)
	{
		//IL_001e: Expected O, but got Unknown
		BrowserMediator.m_c.Debug("Initializing the new RemoteConsoleLoader");
		try
		{
			this.m_b.a(parameters);
		}
		catch (XmlException val)
		{
			XmlException exception = val;
			BrowserMediator.m_c.Error("Exception on parsing parameters. RemoteConsoleLoader initialization failed.", (Exception)(object)exception);
			return;
		}
		catch (Exception exception2)
		{
			BrowserMediator.m_c.Error("Exception on intializing the RemoteConsole Loader. RemoteConsoleLoader initialization failed.", exception2);
			return;
		}
		y y2 = this.m_b.b();
		y2.a((y.b)a);
		y2.b((y.a)b);
		y2.b((y.e)a);
	}

	public void Cleanup()
	{
		BrowserMediator.m_c.Debug("Cleaningup the RemoteConsoleLoader");
		y y2 = this.m_b.b();
		if (y2 != null)
		{
			y2.b((y.b)a);
			y2.a((y.a)b);
			y2.a((y.e)a);
			this.m_b.a();
		}
		if (this.m_g != null)
		{
			((Form)this.m_g).Close();
		}
	}

	public void Connect(int isSwitch, string fromPort, string toPort, string portId, string channelName, string portType, string portPermission)
	{
		BrowserMediator.m_c.Debug("Connect/switch Request for Port: " + toPort);
		this.m_b.b()?.a(isSwitch, fromPort, toPort, portId, channelName, portType, portPermission);
		if (this.m_g != null)
		{
			this.m_g.g();
		}
	}

	public void ConnectPorts(string toPortsString, string portIdsString, string channelNamesString, string portTypesString, string portPermissionsString, string monitorIndexesString, string monitorHorizontalPositionsString, string monitorVerticalPositionsString)
	{
		string[] array = toPortsString.a();
		string[] array2 = portIdsString.a();
		string[] array3 = channelNamesString.a();
		string[] array4 = portTypesString.a();
		string[] array5 = portPermissionsString.a();
		string[] array6 = monitorIndexesString.a();
		string[] array7 = monitorHorizontalPositionsString.a();
		string[] array8 = monitorVerticalPositionsString.a();
		if (array.Length == array2.Length && array.Length == array3.Length && array.Length == array4.Length && array.Length == array5.Length && array.Length == array6.Length && array.Length == array7.Length && array.Length == array8.Length)
		{
			this.m_b.b()?.a(array, array2, array3, array4, array5, array6, array7, array8);
			if (this.m_g != null)
			{
				this.m_g.g();
			}
		}
	}

	public void Disconnect(string port)
	{
		BrowserMediator.m_c.Debug("Disconnect Request for port : " + port);
		this.m_b.b().d(port);
	}

	public void Scan(string indexes, string ids, string names, string types, string perms)
	{
		string[] array = indexes.a();
		string[] array2 = ids.a();
		string[] array3 = names.a();
		string[] array4 = types.a();
		string[] array5 = perms.a();
		if (array.Length == array2.Length && array.Length == array3.Length && array.Length == array4.Length && array.Length == array5.Length)
		{
			a(array, array2, array3, array4, array5, null, null, null, null, null, null, null, null, null, null, null, null);
		}
	}

	public void ScanPorts(string indexes, string ids, string names, string types, string perms, string monitorIndexs, string hpositions, string vpositions, string primaryIndexs, string secondaryIndexs, string secondaryIds, string secondaryNames, string secondaryTypes, string secondaryPerms, string secondaryMonitorIndexs, string secondaryHpositions, string secondaryVpositions)
	{
		string[] array = indexes.a();
		string[] array2 = ids.a();
		string[] array3 = names.a();
		string[] array4 = types.a();
		string[] array5 = perms.a();
		string[] array6 = monitorIndexs.a();
		string[] array7 = hpositions.a();
		string[] array8 = vpositions.a();
		string[] array9 = primaryIndexs.a();
		string[] array10 = secondaryIndexs.a();
		string[] array11 = secondaryIds.a();
		string[] array12 = secondaryNames.a();
		string[] array13 = secondaryTypes.a();
		string[] array14 = secondaryPerms.a();
		string[] array15 = secondaryMonitorIndexs.a();
		string[] array16 = secondaryHpositions.a();
		string[] array17 = secondaryVpositions.a();
		if (array.Length == array2.Length && array.Length == array3.Length && array.Length == array4.Length && array.Length == array5.Length && array.Length == array6.Length && array.Length == array7.Length && array.Length == array8.Length && array9.Length == array10.Length && array9.Length == array11.Length && array9.Length == array12.Length && array9.Length == array13.Length && array9.Length == array14.Length && array9.Length == array15.Length && array9.Length == array16.Length && array9.Length == array17.Length)
		{
			a(array, array2, array3, array4, array5, array6.Select((string A_0) => A_0.b()).ToArray(), array7.Select((string A_0) => A_0.b()).ToArray(), array8.Select((string A_0) => A_0.b()).ToArray(), array9, array10, array11, array12, array13, array14, array15.Select((string A_0) => A_0.b()).ToArray(), array16.Select((string A_0) => A_0.b()).ToArray(), array17.Select((string A_0) => A_0.b()).ToArray());
		}
	}

	private void a(string[] A_0, string[] A_1, string[] A_2, string[] A_3, string[] A_4, int[] A_5, int[] A_6, int[] A_7, string[] A_8, string[] A_9, string[] A_10, string[] A_11, string[] A_12, string[] A_13, int[] A_14, int[] A_15, int[] A_16)
	{
		if (this.m_g != null)
		{
			((Control)this.m_g).BringToFront();
			return;
		}
		b("disableScan", "container_sidebar");
		int num = A_0.Length;
		List<Com.Raritan.RcCore.a> list = new List<Com.Raritan.RcCore.a>(num);
		for (int num2 = 0; num2 < num; num2++)
		{
			if (A_5 != null && A_6 != null && A_7 != null)
			{
				list.Add(new aj(A_0[num2], A_1[num2], A_2[num2], Com.Raritan.KxGui.g.b(A_4[num2]), Com.Raritan.KxGui.g.c(A_4[num2]), Com.Raritan.KxGui.g.a(A_3[num2]), A_5[num2], new Point(A_6[num2], A_7[num2])));
			}
			else
			{
				list.Add(new Com.Raritan.RcCore.a(A_0[num2], A_1[num2], A_2[num2], Com.Raritan.KxGui.g.b(A_4[num2]), Com.Raritan.KxGui.g.c(A_4[num2]), Com.Raritan.KxGui.g.a(A_3[num2])));
			}
		}
		if (A_8 != null)
		{
			num = A_8.Length;
			for (int num3 = 0; num3 < num; num3++)
			{
				string a2 = A_8[num3];
				if (list.FirstOrDefault((Com.Raritan.RcCore.a A_0) => A_0.PortNo.Equals(a2)) is aj aj2)
				{
					aj2.i().Add(new ai(aj2, A_9[num3], A_10[num3], A_11[num3], Com.Raritan.KxGui.g.b(A_13[num3]), Com.Raritan.KxGui.g.c(A_13[num3]), Com.Raritan.KxGui.g.a(A_12[num3]), A_14[num3], new Point(A_15[num3], A_16[num3])));
				}
			}
		}
		this.m_g = new Com.Raritan.KxGui.Scan.g(list.ToArray(), this.m_e, this.m_f, this.m_b);
		((Form)this.m_g).Closed += a;
		((Control)this.m_g).Show();
	}

	private void a(object A_0, EventArgs A_1)
	{
		if (this.m_g != null)
		{
			b("enableScan", "container_sidebar");
			((Component)(object)this.m_g).Dispose();
			this.m_g = null;
		}
	}

	public string GetUsedPorts()
	{
		y y2 = this.m_b.b();
		if (y2 == null)
		{
			return "";
		}
		return y2.a();
	}

	internal void a(string A_0)
	{
		BrowserMediator.m_c.Debug("Calling JavaScript jacConnected for port " + A_0);
		b("jacConnected", "container_sidebar");
	}

	internal void b(string A_0)
	{
		BrowserMediator.m_c.Debug("Calling JavaScript  jacDisconnected for port " + A_0);
		b("jacDisconnected", "container_sidebar");
	}

	internal void a(string A_0, string A_1)
	{
		BrowserMediator.m_c.Debug("Calling JavaScript jacSwitched from port " + A_0 + " to port " + A_1);
		b("jacSwitched", "container_sidebar");
	}

	internal void a()
	{
		BrowserMediator.m_c.Debug("Calling JavaScript logout");
		b("logout", "container_sidebar");
	}

	public string DisplayFavoriteDevices()
	{
		return this.m_d.e();
	}

	public string SetSortMethod(int sortMothod)
	{
		this.m_d.c(sortMothod);
		return this.m_d.e();
	}

	public string GetRetrievalDeviceKeys()
	{
		return this.m_d.d();
	}

	public string GetRetrievalDeviceValues(string key)
	{
		return this.m_d.d(key);
	}

	public bool FavListHasThisKey(string key)
	{
		return this.m_d.f(key);
	}

	public bool FavListHasThisDescr(string key, string deviceDesc)
	{
		return this.m_d.a(key, deviceDesc);
	}

	public string AddDeviceToFavorites(string key, string deviceDesc, string port, string productType)
	{
		this.m_d.a(key, deviceDesc, port, productType);
		return this.m_d.e();
	}

	public string OverwriteDeviceToFavorites(string key, string oldKey, string deviceDesc, string port, string productType)
	{
		this.m_d.a(key, oldKey, deviceDesc, port, productType);
		return this.m_d.e();
	}

	public bool ValidateIpAddress(string addr)
	{
		return this.m_d.c(addr);
	}

	public string DeleteFromFavorites(string deleteDevices)
	{
		this.m_d.e(deleteDevices);
		return this.m_d.e();
	}

	public string DiscoverDevices(string serverIp, int port)
	{
		return this.m_d.a(serverIp, port);
	}

	public int GetBroadcastPort()
	{
		return this.m_d.g();
	}

	public void SetBroadcastPort(int port)
	{
		this.m_d.b(port);
	}

	public string AddDiscoveredToFavorites(string addDevices, bool isServerDiscovered)
	{
		return this.m_d.a(addDevices, isServerDiscovered);
	}

	[CompilerGenerated]
	private static int i(string A_0)
	{
		return A_0.b();
	}

	[CompilerGenerated]
	private static int h(string A_0)
	{
		return A_0.b();
	}

	[CompilerGenerated]
	private static int g(string A_0)
	{
		return A_0.b();
	}

	[CompilerGenerated]
	private static int f(string A_0)
	{
		return A_0.b();
	}

	[CompilerGenerated]
	private static int e(string A_0)
	{
		return A_0.b();
	}

	[CompilerGenerated]
	private static int d(string A_0)
	{
		return A_0.b();
	}
}
