﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:template match="/">
    <ApplicationPreferences>
      <xsl:apply-templates select="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='LogJac']"/>
      <xsl:apply-templates select="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='AlwaysOpenFS']"/>
      <xsl:apply-templates select="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='keyboardType']"/>
      <xsl:apply-templates select="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='SingleMouseExitHotKey']"/>
      <xsl:apply-templates select="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='KeyboardShortcutMenuHotKey']"/>
      <xsl:apply-templates select="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='ConnectionExitHotKey']"/>
      <xsl:apply-templates select="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='broadcastPort']"/>
      <xsl:apply-templates select="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='monitor_akc']"/>
      <xsl:apply-templates select="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='AlwaysOpenSingleMouseMode']"/>
      <xsl:apply-templates select="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='AlwaysOpenScale']"/>
      <xsl:apply-templates select="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='PinMenuToolbar']"/>
      <xsl:apply-templates select="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='ScanDisplayInterval']"/>
      <xsl:apply-templates select="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='PortScanInterval']"/>
      <xsl:apply-templates select="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='ScanThumbnailSize']"/>
      <xsl:apply-templates select="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='ScanOrientation']"/>
    </ApplicationPreferences>
  </xsl:template>

  <xsl:template match="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='LogJac']">
    <LogEnabled>
      <xsl:value-of select="@value"/>
    </LogEnabled>
  </xsl:template>
  <xsl:template match="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='AlwaysOpenFS']">
    <EnableLaunchInFS>
      <xsl:value-of select="@value"/>
    </EnableLaunchInFS>
  </xsl:template>
  <xsl:template match="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='keyboardType']">
    <KeyboardType>
      <xsl:value-of select="@value"/>
    </KeyboardType>
  </xsl:template>
  <xsl:template match="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='SingleMouseExitHotKey']">
    <SingleMouseExitHotKey>
      <xsl:value-of select="@value"/>
    </SingleMouseExitHotKey>
  </xsl:template>
  <xsl:template match="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='KeyboardShortcutMenuHotKey']">
    <KeyboardMenuHotKey>
      <xsl:value-of select="@value"/>
    </KeyboardMenuHotKey>
  </xsl:template>
  <xsl:template match="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='ConnectionExitHotKey']">
    <ConnectionExitHotKey>
      <xsl:value-of select="@value"/>
    </ConnectionExitHotKey>
  </xsl:template>
  <xsl:template match="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='broadcastPort']">
    <BroadcastPort>
      <xsl:value-of select="@value"/>
    </BroadcastPort>
  </xsl:template>
  <xsl:template match="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='monitor_akc']">
    <Monitor>
      <xsl:value-of select="@value"/>
    </Monitor>
  </xsl:template>
  <xsl:template match="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='AlwaysOpenSingleMouseMode']">
    <EnableLaunchWithSMM>
      <xsl:value-of select="@value"/>
    </EnableLaunchWithSMM>
  </xsl:template>
  <xsl:template match="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='AlwaysOpenScale']">
    <EnableLaunchWithScaling>
      <xsl:value-of select="@value"/>
    </EnableLaunchWithScaling>
  </xsl:template>
  <xsl:template match="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='PinMenuToolbar']">
    <PinMenuToolbar>
      <xsl:value-of select="@value"/>
    </PinMenuToolbar>
  </xsl:template>
  <xsl:template match="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='ScanDisplayInterval']">
    <ScanDisplayInterval>
      <xsl:value-of select="@value"/>
    </ScanDisplayInterval>
  </xsl:template>
  <xsl:template match="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='PortScanInterval']">
    <PortScanInterval>
      <xsl:value-of select="@value"/>
    </PortScanInterval>
  </xsl:template>
  <xsl:template match="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='ScanThumbnailSize']">
    <ScanThumbnailSize>
      <xsl:value-of select="@value"/>
    </ScanThumbnailSize>
  </xsl:template>
  <xsl:template match="preferences/root[@type='user']/node[@name='ApplicationSettings']/map/entry[@key='ScanOrientation']">
    <ScanOrientation>
      <xsl:value-of select="@value"/>
    </ScanOrientation>
  </xsl:template>
</xsl:stylesheet>
