<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="/">
    <KeyboardMacroArray>
      <AkcKeyboardMacros>
        <xsl:for-each select="preferences/root[@type='user']/node[@name='AkcKeyboardMacros']/node">
          <KeyboardMacro>
		        <Name><xsl:value-of select="map/entry[@key='name']/@value"/></Name>
		        <HotKey><xsl:value-of select="map/entry[@key='hotKey']/@value"/></HotKey>
		        <MacroSequence><xsl:value-of select="map/entry[@key='macroSequence']/@value"/></MacroSequence>
          </KeyboardMacro>
        </xsl:for-each>
      </AkcKeyboardMacros>
    </KeyboardMacroArray>
	</xsl:template>
</xsl:stylesheet>