using System;
using System.Drawing;
using Com.Raritan.Core;
using Com.Raritan.Core.Impl;
using log4net;

namespace Com.Raritan.RcCore.Impl.Rfb.Encodings;

internal class b : a
{
	private new class a
	{
		public bool a;

		public bool b;

		public bool c;

		public int d;

		public int e;

		public a(bool A_0, bool A_1, bool A_2, int A_3, int A_4)
		{
			c = A_0;
			this.a = A_1;
			b = A_2;
			d = A_3;
			e = A_4;
		}

		public virtual string a()
		{
			return string.Copy("Compact=" + this.a + ",Grey=" + b + ",Depth=" + d + ",GreyDepth=" + e);
		}
	}

	private new class b
	{
		public uint a;

		public uint[] b;

		public uint[] c;

		public a d;

		private ILog e;

		private a[] f = new a[14]
		{
			new a(A_0: false, A_1: false, A_2: false, 15, 6),
			new a(A_0: false, A_1: false, A_2: false, 15, 6),
			new a(A_0: false, A_1: false, A_2: false, 7, 4),
			new a(A_0: false, A_1: false, A_2: false, 7, 4),
			new a(A_0: false, A_1: true, A_2: false, 4, 4),
			new a(A_0: false, A_1: true, A_2: false, 4, 4),
			new a(A_0: false, A_1: true, A_2: true, 4, 4),
			new a(A_0: false, A_1: true, A_2: true, 4, 4),
			new a(A_0: false, A_1: true, A_2: true, 3, 3),
			new a(A_0: false, A_1: true, A_2: true, 3, 3),
			new a(A_0: true, A_1: false, A_2: true, 2, 2),
			new a(A_0: true, A_1: false, A_2: true, 2, 2),
			new a(A_0: true, A_1: false, A_2: true, 1, 1),
			new a(A_0: true, A_1: false, A_2: true, 1, 1)
		};

		public b(uint A_0, ILog A_1)
		{
			e = A_1;
			this.a = A_0;
			A_1.InfoFormat(Com.Raritan.Core.b.d("new LRLE color decoder type {0}"), this.a);
			b();
			a();
		}

		private void b()
		{
			if (this.a < f.Length)
			{
				d = f[this.a];
				e.Info(d.ToString());
			}
			else
			{
				e.FatalFormat(Com.Raritan.Core.b.d("ERROR: unsupported color decoder type: {0}"), this.a);
			}
		}

		private void a()
		{
			c = new uint[1 << d.e];
			if (d.b)
			{
				this.b = new uint[1 << d.e];
			}
			for (uint num = 0u; num < 1 << d.e; num++)
			{
				c[num] = 4278190080u;
				switch (d.e)
				{
				case 1:
					c[num] |= (num * 255 << 16) | (num * 255 << 8) | (num * 255);
					break;
				case 2:
					c[num] |= (num * 85 << 16) | (num * 85 << 8) | (num * 85);
					break;
				case 3:
					c[num] |= (num * 73 / 2 << 16) | (num * 73 / 2 << 8) | (num * 73 / 2);
					break;
				case 4:
					c[num] |= (num * 17 << 16) | (num * 17 << 8) | (num * 17);
					break;
				case 5:
					c[num] |= (num * 33 / 4 << 16) | (num * 33 / 4 << 8) | (num * 33 / 4);
					break;
				case 6:
					c[num] |= (num * 65 / 16 << 16) | (num * 65 / 16 << 8) | (num * 65 / 16);
					break;
				default:
					c[num] |= 16711935u;
					break;
				}
				if (d.b)
				{
					this.b[num] = c[num];
				}
			}
			if (d.b)
			{
				return;
			}
			this.b = new uint[1 << d.d];
			switch (d.d)
			{
			case 4:
				this.b[0] = 4278190080u;
				this.b[1] = 4286513152u;
				this.b[2] = 4278222592u;
				this.b[3] = 4286545664u;
				this.b[4] = 4278190207u;
				this.b[5] = 4286513279u;
				this.b[6] = 4278222719u;
				this.b[7] = 4286545791u;
				this.b[8] = 4290822336u;
				this.b[9] = 4294901760u;
				this.b[10] = 4278255360u;
				this.b[11] = 4294967040u;
				this.b[12] = 4278190335u;
				this.b[13] = 4294902015u;
				this.b[14] = 4278255615u;
				this.b[15] = uint.MaxValue;
				break;
			case 7:
			{
				uint[] array = new uint[5] { 0u, 64u, 128u, 192u, 255u };
				for (uint num = 0u; num < 125; num++)
				{
					this.b[num] = 0xFF000000u | (array[num / 25] << 16) | (array[num / 5 % 5] << 8) | array[num % 5];
				}
				for (uint num = 125u; num < 128; num++)
				{
					this.b[num] = 4294901760u;
				}
				break;
			}
			case 15:
			{
				for (uint num = 0u; num < 1 << d.d; num++)
				{
					this.b[num] = 0xFF000000u | (((num & 0x7C00) >> 10) * 33 / 4 << 16) | (((num & 0x3E0) >> 5) * 33 / 4 << 8) | ((num & 0x1F) * 33 / 4);
				}
				break;
			}
			}
		}
	}

	private new const uint m_a = 268435455u;

	private new b m_b;

	private new uint c = 268435455u;

	private new uint[] d;

	private bool e;

	public b(ILog A_0, i A_1)
		: base(A_0, A_1)
	{
	}

	public override void a()
	{
		this.m_b = null;
		d = null;
		base.a();
	}

	void IDisposable.Dispose()
	{
		//ILSpy generated this explicit interface implementation from .override directive in a
		this.a();
	}

	private void a(Com.Raritan.Core.Impl.e A_0, int[] A_1, int A_2, int A_3, int A_4, int A_5, int A_6, int A_7)
	{
		int num = 8 / this.m_b.d.e;
		int num2 = (1 << this.m_b.d.e) - 1;
		int num3 = A_6 / num;
		int num4 = A_6 % num;
		for (int i = 0; i < A_7; i++)
		{
			for (int j = 0; j < num3; j++)
			{
				int num5 = a(A_0);
				for (int num6 = num - 1; num6 >= 0; num6--)
				{
					A_1[A_2 + i * A_3 + j * num + num6] = (int)this.m_b.c[num5 & num2];
					num5 >>= this.m_b.d.e;
				}
			}
			if (num4 != 0)
			{
				int num5 = a(A_0);
				for (int num6 = num4 - 1; num6 >= 0; num6--)
				{
					A_1[A_2 + i * A_3 + num3 * num + num6] = (int)this.m_b.c[num5 & num2];
					num5 >>= this.m_b.d.e;
				}
			}
		}
	}

	public override int[] a(Com.Raritan.Core.Impl.e A_0, uint A_1, uint A_2, Rectangle A_3, Size A_4, Size A_5, Com.Raritan.RcCore.Impl.Rfb.a A_6)
	{
		a(A_3);
		if (d == null || d.Length < A_5.Width)
		{
			d = new uint[A_5.Width];
		}
		d.Initialize();
		int x = A_3.X;
		int y = A_3.Y;
		int width = A_3.Width;
		int height = A_3.Height;
		int num = 0;
		int num2 = 0;
		uint num3 = 4278190080u;
		if (c == 268435455 || c != A_2)
		{
			c = A_2;
			this.m_b = new b(c, base.c);
		}
		for (int i = y; i < y + height; i += 16)
		{
			for (int j = x; j < x + width; j += 16)
			{
				int num4 = (i - y) * width + (j - x);
				int num5 = 16;
				int num6 = 16;
				if (x + width - j < 16)
				{
					num5 = x + width - j;
				}
				if (y + height - i < 16)
				{
					num6 = y + height - i;
				}
				if (this.m_b.d.c)
				{
					a(A_0, g, num4, width, j, i, num5, num6);
					continue;
				}
				int num7;
				int num8 = (num7 = 0);
				int num9;
				int num10 = (num9 = 0);
				if (e)
				{
					Console.WriteLine("Tile (" + j + "," + i + ")");
				}
				while (true)
				{
					if (e)
					{
						Console.Write("(" + num8 + "," + num7 + ")");
					}
					if (num8 == 0 && num9 + num7 == num6)
					{
						break;
					}
					int num11 = a(A_0);
					if (e)
					{
						Console.Write(" Code=0x" + num11.ToString("X") + " -> ");
					}
					if ((num11 & 0xE0) == 224)
					{
						num2 = 1;
						num = ((num11 == 255) ? a(A_0) : (num11 & 0x1F));
						if (e)
						{
							Console.WriteLine("COPY " + (num + 1));
						}
					}
					else if (this.m_b.d.a)
					{
						num2 = 0;
						if (this.m_b.d.d <= 3)
						{
							num3 = this.m_b.b[num11 & 7];
							num = num11 >> 3;
							if (e)
							{
								Console.WriteLine("PIXEL=0x" + (num11 & 7).ToString("X") + " (RUN=" + (num + 1) + ") -> 0x" + num3.ToString("X"));
							}
						}
						else
						{
							num3 = this.m_b.b[num11 & 0xF];
							num = num11 >> 4;
							if (e)
							{
								Console.WriteLine("PIXEL=0x" + (num11 & 0xF).ToString("X") + " (RUN=" + (num + 1) + ") -> 0x" + num3.ToString("X"));
							}
						}
					}
					else
					{
						switch ((num11 & 0xC0) >> 6)
						{
						case 0:
						case 1:
							if (this.m_b.d.d > 7)
							{
								num11 = (num11 << 8) | a(A_0);
							}
							num3 = this.m_b.b[num11];
							if (e)
							{
								Console.WriteLine("PIXEL=0x" + num11.ToString("X") + " -> 0x" + num3.ToString("X"));
							}
							num = 0;
							num2 = 0;
							break;
						case 2:
							num3 = this.m_b.c[num11 & 0x3F];
							if (e)
							{
								Console.WriteLine("GREY=0x" + num11.ToString("X") + " -> 0x" + num3.ToString("X"));
							}
							num = 0;
							num2 = 0;
							break;
						case 3:
							num = num11 & 0x1F;
							break;
						}
					}
					for (int k = 0; k <= num; k++)
					{
						if (num2 == 0)
						{
							d[num8] = num3;
						}
						g[num4 + (num9 + num7) * width + num10 + num8] = (int)d[num8];
						num8++;
						if (num10 + num8 == num5)
						{
							num8 = 0;
							num7++;
						}
					}
				}
				if (e)
				{
					Console.WriteLine(" >>END OF TILE");
				}
			}
		}
		b(A_0);
		return g;
	}
}
