using System;
using System.IO;
using System.Security.Cryptography;
using Com.Raritan.Core;
using Com.Raritan.Core.Impl;
using log4net;

namespace Com.Raritan.RcCore.Impl.Rfb.V01_28;

internal class ap
{
	private const int m_a = -1;

	private const int b = 0;

	private const int c = 1;

	private const int d = 2;

	private const int e = 3;

	private Com.Raritan.RcCore.Impl.Rfb.i f;

	private ILog g;

	protected string h;

	protected string i;

	protected string j;

	protected string k;

	private HashAlgorithm l;

	private uint m;

	private int n = -1;

	public ap(Com.Raritan.RcCore.Impl.Rfb.i A_0, ILog A_1)
	{
		f = A_0;
		g = A_1;
	}

	public void a(uint A_0, string A_1, string A_2, string A_3, string A_4)
	{
		m = A_0;
		h = A_1;
		i = A_2;
		j = A_3;
		k = A_4;
	}

	public void a()
	{
		if (n == -1 && (m & 4) != 0 && h != null && i != null)
		{
			l = HashAlgorithm.Create("MD5");
			if (l != null)
			{
				g.Debug(Com.Raritan.Core.b.d("Using MD5 authentication"));
				n = 1;
			}
			else
			{
				g.Warn(Com.Raritan.Core.b.d("MD5 not available."));
			}
		}
		if (n == -1)
		{
			if ((m & 2) != 0 && h != null && i != null)
			{
				g.Debug(Com.Raritan.Core.b.d("Using Plain authentication"));
				n = 0;
			}
			else if ((m & 0x10) != 0 && k != null)
			{
				g.Debug(Com.Raritan.Core.b.d("Using RDM Session ID authentication"));
				n = 3;
			}
			else if ((m & 1) != 0 && j != null)
			{
				g.Debug(Com.Raritan.Core.b.d("Using HTTP Session ID authentication"));
				n = 2;
			}
		}
		switch (n)
		{
		case 0:
			f.a(h, 2u, 0u);
			break;
		case 1:
			f.a(h, 4u, 0u);
			break;
		case 3:
			f.a("super", 16u, 0u);
			break;
		case 2:
			f.a("", 1u, 0u);
			break;
		default:
			throw new Com.Raritan.RcCore.u(Com.Raritan.Core.b.d("No proper authentication scheme found"));
		}
	}

	public void a(byte[] A_0)
	{
		switch (n)
		{
		case 0:
			if (A_0 != null)
			{
				throw new Com.Raritan.RcCore.u(Com.Raritan.Core.b.d("Protocol error: bad challenge size"));
			}
			f.c(i);
			break;
		case 1:
		{
			using MemoryStream memoryStream = new MemoryStream();
			if (A_0 != null)
			{
				memoryStream.Write(A_0, 0, A_0.Length);
			}
			byte[] array = Com.Raritan.Core.Impl.f.b(i);
			memoryStream.Write(array, 0, array.Length);
			memoryStream.Position = 0L;
			byte[] a_ = l.ComputeHash(memoryStream);
			string a_2 = Com.Raritan.Core.Impl.p.a(a_);
			f.c(a_2);
			break;
		}
		case 2:
		{
			if (A_0 == null || A_0.Length != 65)
			{
				throw new Com.Raritan.RcCore.u(Com.Raritan.Core.b.d("Protocol error: bad challenge size"));
			}
			string text = Com.Raritan.Core.Impl.f.b(A_0);
			Com.Raritan.Core.Impl.i.b a_3 = (text.StartsWith("{SHA256}") ? Com.Raritan.Core.Impl.i.b.c : Com.Raritan.Core.Impl.i.b.a);
			byte[] array2 = new byte[64];
			Array.Copy(A_0, array2, 64);
			string text2 = f.a(array2, a_3);
			f.c(text2 + '\0');
			break;
		}
		case 3:
			if (A_0 != null)
			{
				throw new Com.Raritan.RcCore.u(Com.Raritan.Core.b.d("Protocol error: bad challenge size"));
			}
			f.c(k + '\0');
			break;
		default:
			throw new Com.Raritan.RcCore.u(Com.Raritan.Core.b.d("No proper authentication scheme found"));
		}
	}
}
