using System;
using System.IO;
using Com.Raritan.Core;
using Com.Raritan.Core.Impl;
using log4net;

namespace Com.Raritan.VmCore.Impl.Media;

internal class k : i
{
	private new const int m_a = 5;

	private new const int m_b = 32769;

	private new const string m_c = "CD001";

	private new string m_d;

	private new FileStream m_e;

	private new int f;

	private new long g;

	public k(string A_0, bool A_1, ILog A_2)
		: base(A_1, A_2)
	{
		this.m_d = A_0;
	}

	public override void a(Com.Raritan.VmCore.a.a A_0, Com.Raritan.VmCore.Impl.c A_1)
	{
		lock (base.g)
		{
			if (base.e)
			{
				this.m_e = File.Open(this.m_d, FileMode.Open, FileAccess.Read, FileShare.Read);
			}
			else
			{
				this.m_e = File.Open(this.m_d, FileMode.Open, FileAccess.ReadWrite, FileShare.None);
			}
		}
	}

	public override void c()
	{
		lock (base.g)
		{
			if (this.m_e == null)
			{
				return;
			}
			if (!base.e)
			{
				try
				{
					this.m_e.Flush();
				}
				catch (Exception)
				{
				}
			}
			this.m_e.Close();
			this.m_e = null;
		}
	}

	public override void a(bool A_0)
	{
	}

	public override int a()
	{
		return f;
	}

	public override long d()
	{
		return g;
	}

	public override void b()
	{
		lock (base.g)
		{
			if (k())
			{
				a(Com.Raritan.VmCore.a.c.b);
				f = 2048;
			}
			else if (j())
			{
				a(Com.Raritan.VmCore.a.c.c);
				f = 512;
			}
			else if (i())
			{
				a(Com.Raritan.VmCore.a.c.d);
				f = 512;
			}
			else
			{
				if (!e())
				{
					throw new IOException(Com.Raritan.Core.b.d("Invalid image file"));
				}
				a(Com.Raritan.VmCore.a.c.e);
				f = 512;
			}
			g = this.m_e.Length / f - 1;
		}
	}

	public override void a(long A_0, int A_1, byte[] A_2)
	{
		lock (base.g)
		{
			this.m_e.Seek(A_0 * f, SeekOrigin.Begin);
			a(A_2, 0, A_1 * f);
		}
	}

	public override void b(long A_0, int A_1, byte[] A_2)
	{
		if (base.e)
		{
			throw new Com.Raritan.VmCore.d(Com.Raritan.Core.b.d("Writing not supported"));
		}
		lock (base.g)
		{
			this.m_e.Seek(A_0 * f, SeekOrigin.Begin);
			this.m_e.Write(A_2, 0, A_1 * f);
		}
	}

	private new void a(byte[] A_0, int A_1, int A_2)
	{
		if (A_2 < 0)
		{
			throw new ArgumentException();
		}
		int num;
		for (int n = 0; n < A_2; n += num)
		{
			num = this.m_e.Read(A_0, A_1 + n, A_2 - n);
			if (num < 0)
			{
				throw new EndOfStreamException();
			}
		}
	}

	private bool k()
	{
		long length = this.m_e.Length;
		if (length < 32774 || length % 512 != 0)
		{
			base.f.Debug("Image file is not a ISO image, size doesn't match!");
			return false;
		}
		byte[] a_ = new byte[5];
		try
		{
			long position = this.m_e.Position;
			this.m_e.Seek(32769L, SeekOrigin.Begin);
			a(a_, 0, 5);
			this.m_e.Seek(position, SeekOrigin.Begin);
		}
		catch (IOException)
		{
			return false;
		}
		string text = Com.Raritan.Core.Impl.f.b(a_);
		if (!"CD001".Equals(text))
		{
			base.f.Debug("Image file is not a ISO image, tag doesn't match (" + text + " - CD001)");
			return false;
		}
		base.f.Debug("Image file is ISO image");
		return true;
	}

	private bool j()
	{
		long length = this.m_e.Length;
		if (length > 2949120 || length < 163840 || length % 512 != 0)
		{
			base.f.Debug("Image file is not a floppy image!");
			return false;
		}
		base.f.Debug("Image file is floppy image");
		return true;
	}

	private bool i()
	{
		long length = this.m_e.Length;
		if (length < 163840 || length % 512 != 0)
		{
			base.f.Debug("Image file is not a removable image!");
			return false;
		}
		base.f.Debug("Image file is removable image");
		return true;
	}

	private new bool e()
	{
		return false;
	}
}
